// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ngCordova', 'starter.controllers', 'starter.filter', 'starter.services'])
  .run(function ($rootScope, $ionicPlatform, $ionicHistory, $ionicPopup, $location, $cordovaInAppBrowser, $cordovaStatusbar, $state, $http, CheckUserLogin, jpushService, Storage, Public, Variable) {
    $ionicPlatform.ready(function () {

      $ionicPlatform.registerBackButtonAction(function (e) {
        e.preventDefault();
        $ionicHistory.goBack();
        if ($location.path() == '/tab/index') {
          var confirmPopup = $ionicPopup.confirm({
            title: '警告',
            template: '你确定要退出应用吗？',
            okText: '确定',
            cancelText: '取消'
          });
          confirmPopup.then(function (res) {
            if (res) {
              ionic.Platform.exitApp();
            } else { }
          });
        }
        return false;
      }, 101);

      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
        // cordova.plugins.Keyboard.disableScroll(true);

      }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        // StatusBar.styleDefault();
        // StatusBar.overlaysWebView(true);
        if (device.platform == "Android") {
          // StatusBar.overlaysWebView(false);
          // StatusBar.backgroundColorByName("white");
        } else {
          StatusBar.styleDefault();
        }
      }

      // navigator.splashscreen.hide();


      if (window.cordova && window.cordova.InAppBrowser) {
        window.open = window.cordova.InAppBrowser.open;
      }

      if (window.cordova && window.cordova.plugins.Keyboard) {
        window.cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
        if (window.ionic.Platform.isIOS()) {
          window.cordova.plugins.Keyboard.disableScroll(true);
        }
      }

      // $cordovaInAppBrowser.insertCSS({
      //      code: 'body {background-color:red;}'
      // });
      $rootScope.$on('$cordovaInAppBrowser:loadstart', function (e, event) {
        // alert(1);
        // SpinnerPlugin.activityStart("加载中...", '');

        // window.plugins.spinnerDialog.show();
        if (event.url.match("closeMobile=true")) {
          $cordovaInAppBrowser.close();
          CheckUserLogin(); //检查用户是否登录
          return;
        }
        var url = event.url.replace('https://', '');

        // 物业判断：
        if (url == Variable.url + '/platform') {
          $location.path('/tab/pcuser');
          CheckUserLogin(); //检查用户是否登录
          $cordovaInAppBrowser.close();
          return;
        }

        // 预约
        if (url.match('platform/appointment') && !url.match('platform/appointment/info')) {
          CheckUserLogin();
          $cordovaInAppBrowser.close();
          $state.go("tab.pc-appt", {}, {
            reload: true
          });
          return;
        } else if (url.match('user/appointment') && !url.match('user/appointment/info')) {
          CheckUserLogin();
          $cordovaInAppBrowser.close();
          $state.go("tab.user-appointment", {}, {
            reload: true
          });
          return;
        } else if (url.match('/index') && !url.match('/user/')) {
          CheckUserLogin();
          $cordovaInAppBrowser.close();
          $state.go("tab.index", {}, {
            reload: true
          });
          return;
        } else if (url.match('/user') && !url.match('/user/') && !url.match('user/appointment')) {
          CheckUserLogin();
          $cordovaInAppBrowser.close();
          $state.go("tab.user", {}, {
            reload: true
          });
          return;
        }

        if (!url.match("yizhaofang")) {
          url = url.split('/');
          if (url['2'] == 'index') {
            $cordovaInAppBrowser.close();
            CheckUserLogin(); //检查用户是否登录
            if (url['1'] == 'mcity') {
              $location.path('/tab/index/city');
            } else {
              $location.path('/tab/index');
            }
            return;
          }
        }
      });
      $rootScope.$on('$cordovaInAppBrowser:loadstop', function (e, event) {
        // alert(2);
        // SpinnerPlugin.activityStop();
        // window.plugins.spinnerDialog.hide();
        var url = event.url.replace('https://', '');

        if (url.match('platform/appointment/info') || url.match('user/apptInfo') || url.match('user/apt/info')) {
          $cordovaInAppBrowser.executeScript({
            code: 'opener?opener.location.href="https://m.zufun.cn/?closeMobile=true":opener={location:{href:"https://m.zufun.cn/?closeMobile=true"}};if(history.length==1){var url=window.location.pathname;history.replaceState("closeMobile",null,"/?closeMobile=true");history.pushState(null,null,url);}window.addEventListener("popstate",function(){if(history.state=="closeMobile"){window.location.href="/?closeMobile=true";}});'
          });
        }
        if (url.match('protocol=user')) {
          $cordovaInAppBrowser.executeScript({
            code: '$(".header .back").attr("href","/user");'
          });
        }
        if (url.match('user/appointPage')) {
          $cordovaInAppBrowser.executeScript({
            code: 'if(!$("#phone-num").val()){$("#phone-num").val(' + (Storage.get('own_number') ? Storage.get('own_number') : '') + ').trigger("input");}'
          });
        }
      });

      $rootScope.$on('$cordovaInAppBrowser:exit', function (e, event) {
        // console.log("----------------666")
        CheckUserLogin();
        $cordovaInAppBrowser.close();
        $state.go("tab.index", {}, { reload: true });
      });

      $rootScope.$on('$cordovaInAppBrowser:loaderror', function (e, event) {
        console.log(e);
        console.log(event);
      });

      //   //推送初始化
      //   var setTagsWithAliasCallback = function (event) {
      //     switch (event.resultCode) {
      //       case 6002:
      //         setTimeout(function () {
      //           jpushService.setAlias(Storage.get('fu_app_id'));
      //         }, 60000);
      //         break;

      //     }
      //   };
      //   var openNotificationInAndroidCallback = function (data) {
      //     var json = data,
      //       route = '',
      //       id = '',
      //       type = '';
      //     if (typeof data === 'string') {
      //       json = JSON.parse(data);
      //     }
      //     if (device.platform == "Android") {
      //       route = json.extras['cn.jpush.android.EXTRA'].route;
      //       id = json.extras['cn.jpush.android.EXTRA'].id;
      //       type = json.extras['cn.jpush.android.EXTRA'].type;
      //     } else {
      //       route = json.route;
      //       id = json.id;
      //       type = json.type;
      //     }

      //     if ('promote' == type) {
      //       Public.openLinkInApp(route);
      //     } else {
      //       if (Storage.get('isPcUser')) {
      //         CheckUserLogin(); //检查消息数量；
      //         $state.go('tab.pcmessage');
      //       } else {
      //         CheckUserLogin(); //检查消息数量；
      //         $state.go('tab.message');
      //       }
      //     }

      //   };
      //   //点击推送通知： 
      //   var onOpenNotification = function (event) {
      //     if ('promote' == event.type) {
      //       Public.openLinkInApp(event.route);
      //     } else {
      //       CheckUserLogin(); //检查消息数量；
      //       if (Storage.get('isPcUser')) {
      //         $state.go('tab.pcmessage');
      //       } else {
      //         $state.go('tab.message');
      //       }
      //       jpushService.setApplicationIconBadgeNumber(0);
      //       jpushService.setBadge(0);
      //     }
      //   };

      //   // 前台收到推送：
      //   var onReceiveNotification = function (event) {
      //     // var alertContent
      //     // alertContent = event.aps.alert
      //     // alert("open Notificaiton:" + alertContent)
      //     // 
      //     // alert("前台获取");
      //   };

      //   //后台收到推送：
      //   var onBackgroundNotification = function (event) {
      //     // var alertContent
      //     // alertContent = event.aps.alert
      //     // alert("open Notificaiton:" + alertContent);
      //     // alert("后台获取");

      //     // window.plugins.jPushPlugin.prototype.setBadge(value)
      //     // window.plugins.jPushPlugin.prototype.reSetBadge()
      //     window.plugins.jPushPlugin.getApplicationIconBadgeNumber(function (data) {
      //       jpushService.setApplicationIconBadgeNumber(data + 1);
      //     });
      //   };

      //   var config = {
      //     stac: setTagsWithAliasCallback,
      //     oniac: openNotificationInAndroidCallback,
      //     onOpenNotification: onOpenNotification, //点击推送通知；
      //     onReceiveNotification: onReceiveNotification, //前台收到消息；
      //     onBackgroundNotification: onBackgroundNotification //后台收到消息：
      //   };

      //   jpushService.init(config);
      //   jpushService.setApplicationIconBadgeNumber(0);
    });

    $rootScope.jumbotronClass = 'jumbotronAndroid';
    document.addEventListener('deviceready', function () {
      if (device.platform == "Android") {
        $rootScope.jumbotronClass = 'jumbotronAndroid';
      } else {
        $rootScope.jumbotronClass = 'jumbotronIos';
        Storage.set('StatusBarHeight', 20);
      }

      //   var fu_app_id;
      //   if (Storage.get('fu_app_id')) {
      //     fu_app_id = Storage.get('fu_app_id');
      //   } else {
      //     fu_app_id = '';
      //   }
      //   var app_data = {
      //     uuid: device.uuid,
      //     cordova: device.cordova,
      //     version: device.version,
      //     platform: device.platform,
      //     fu_app_id: fu_app_id
      //   };
      //   var app_url = "https://" + Variable.url + "/index/getAppidByIonic?" + $.param(app_data) + "&callback=JSON_CALLBACK";
      //   $http.jsonp(app_url).success(
      //     function (ret) {
      //       if (ret.code === 0) {
      //         Storage.set('fu_app_id', ret.data);
      //         jpushService.setAlias(ret.data);
      //       }
      //     }
      //   ).error(function (err, status) {
      //     console.log('err:' + err);
      //   });

      if (!Storage.get('own_number')) {
        if (Storage.get('protocol')) {
          console.log("zf 已通过隐私协议 申请手机权限");
          if (device.platform == "Android") {
            var permissions = cordova.plugins.permissions;
            permissions.hasPermission(permissions.READ_PHONE_STATE, function (status) {
              if (status.hasPermission) {
                window.plugins.sim.getSimInfo(function (res) {
                  Storage.set('own_number', res.phoneNumber.replace(/\+?86/, ''));
                });
              } else {
                permissions.requestPermission(permissions.READ_PHONE_STATE, function (status) {
                  if (status.hasPermission) {
                    window.plugins.sim.getSimInfo(function (res) {
                      Storage.set('own_number', res.phoneNumber.replace(/\+?86/, ''));
                    });
                  }
                });
              }
            });
          } else if (device.platform == "iOS") {
            window.plugins.sim.getSimInfo(function (res) {
              Storage.set('own_number', res.phoneNumber.replace(/\+?86/, ''));
            });
          } else if (device.platform == "browser") {
            console.log("zf brwser 调用 请求");
          }
        }
      }
      if (device.platform == "Android" && Storage.get('protocol') || device.platform == "iOS") {
        Public.checkUpdate();
      }

    }, false);
  })
  .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
    //配置android,导航在底部；
    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('standard');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');

    $ionicConfigProvider.views.swipeBackEnabled(false);
    // Ionic uses AngularUI Router which uses the concept of states
    // Learn more here: https://github.com/angular-ui/ui-router
    // Set up the various states which the app can be in.
    // Each state's controller can be found in controllers.js
    $stateProvider

      // setup an abstract state for the tabs directive
      .state('tab', {
        url: '/tab',
        abstract: true,
        templateUrl: 'templates/tabs.html',
        controller: 'TabCtrl'
      })
      //开机画面路由
      //.state('tab.slideBox', {
      //  url: '/slideBox',
      //  cache:'false',
      //  views: {
      //    'tab-index': {
      //      templateUrl: 'templates/slide_box.html',
      //      controller: 'SlideBoxCtrl'
      //    }
      //  }
      //})
      // Each tab has its own nav history stack:
      .state('tab.index', {
        url: '/index',
        cache: 'false',
        views: {
          'tab-index': {
            templateUrl: 'templates/common/index.html',
            controller: 'IndexCtrl'
          }
        }
      })
      // 预约看房界面
      .state('tab.apart-login', {
        url: '/apart/login',
        views: {
          'tab-index': {
            templateUrl: 'templates/login/login.html',
            controller: 'LoginCtrl'
          }
        }
      })
      .state('tab.apart-quicklogin', {
        url: '/apart/quicklogin',
        views: {
          'tab-index': {
            templateUrl: 'templates/login/quicklogin.html',
            controller: 'QuickLoginCtrl'
          }
        }
      })
      .state('tab.apart-register', {
        url: '/apart/register',
        views: {
          'tab-index': {
            templateUrl: 'templates/login/register.html',
            controller: 'RegisterCtrl'
          }
        }
      })
      .state('tab.apart-forgetpwd', {
        url: '/apart/forgetpwd',
        views: {
          'tab-index': {
            templateUrl: 'templates/login/forget_pwd.html',
            controller: 'ForgetpwdCtrl'
          }
        }
      })
      .state('tab.index-city', {
        url: '/index/city',
        cache: 'false',
        views: {
          'tab-index': {
            templateUrl: 'templates/common/city.html',
            controller: 'IndexCityCtrl'
          }
        }
      })
      .state('tab.index-pcmessage', {
        url: '/index/pcmessage',
        cache: 'false',
        views: {
          'tab-index': {
            templateUrl: 'templates/user/pcmessage.html',
            controller: 'PcMessageCtrl'
          }
        }
      })
      .state('tab.index-message', {
        url: '/index/message',
        cache: 'false',
        views: {
          'tab-index': {
            templateUrl: 'templates/user/message.html',
            controller: 'UserMessageCtrl'
          }
        }
      })
      .state('tab.index-search', {
        url: '/index/search',
        cache: 'false',
        views: {
          'tab-index': {
            templateUrl: 'templates/common/search.html',
            controller: 'SearchCtrl'
          }
        }
      })
      // 物业消息：
      .state('tab.pcmessage', {
        url: '/pcmessage',
        cache: 'false',
        views: {
          'tab-message': {
            templateUrl: 'templates/user/pcmessage.html',
            controller: 'PcMessageCtrl'
          }
        }
      })
      //消息中心
      .state('tab.message', {
        url: '/message',
        cache: 'false',
        views: {
          'tab-message': {
            templateUrl: 'templates/user/message.html',
            controller: 'UserMessageCtrl'
          }
        }
      })
      .state('tab.message-login', {
        url: '/message/login',
        views: {
          'tab-message': {
            templateUrl: 'templates/login/login.html',
            controller: 'LoginCtrl'
          }
        }
      })
      .state('tab.message-quicklogin', {
        url: '/message/quicklogin',
        views: {
          'tab-message': {
            templateUrl: 'templates/login/quicklogin.html',
            controller: 'QuickLoginCtrl'
          }
        }
      })
      .state('tab.message-register', {
        url: '/message/register',
        views: {
          'tab-message': {
            templateUrl: 'templates/login/register.html',
            controller: 'RegisterCtrl'
          }
        }
      })
      .state('tab.message-forgetpwd', {
        url: '/message/forgetpwd',
        views: {
          'tab-message': {
            templateUrl: 'templates/login/forget_pwd.html',
            controller: 'ForgetpwdCtrl'
          }
        }
      })
      /*
      注册、登录、找回密码
      */
      .state('tab.user-login', {
        url: '/login',
        views: {
          'tab-user': {
            templateUrl: 'templates/login/login.html',
            controller: 'LoginCtrl'
          }
        }
      })
      .state('tab.user-quicklogin', {
        url: '/quicklogin',
        views: {
          'tab-user': {
            templateUrl: 'templates/login/quicklogin.html',
            controller: 'QuickLoginCtrl'
          }
        }
      })
      .state('tab.user-register', {
        url: '/register',
        views: {
          'tab-user': {
            templateUrl: 'templates/login/register.html',
            controller: 'RegisterCtrl'
          }
        }
      })
      .state('tab.user-forgetpwd', {
        url: '/forgetpwd',
        views: {
          'tab-user': {
            templateUrl: 'templates/login/forget_pwd.html',
            controller: 'ForgetpwdCtrl'
          }
        }
      })
      .state('tab.pc-user', {
        url: '/pcuser',
        views: {
          'tab-user': {
            templateUrl: 'templates/user/pcuser.html',
            controller: 'PcUserCtrl'
          }
        }
      })
      .state('tab.user', {
        url: '/user',
        views: {
          'tab-user': {
            templateUrl: 'templates/user/index.html',
            controller: 'UserIndexCtrl'
          }
        }
      })
      // 物业预约；
      .state('tab.pc-appt', {
        cache: 'false',
        url: '/pcappt',
        views: {
          'tab-appointment': {
            templateUrl: 'templates/user/pcappt.html',
            controller: 'PcApptCtrl'
          }
        }
      })
      //我的预约
      .state('tab.user-appointment', {
        cache: 'false',
        url: '/appointment',
        views: {
          'tab-appointment': {
            templateUrl: 'templates/user/appt.html',
            controller: 'UserAppointmentCtrl'
          }
        }
      })
      .state('tab.appointment-login', {
        url: '/appointment/login',
        views: {
          'tab-appointment': {
            templateUrl: 'templates/login/login.html',
            controller: 'LoginCtrl'
          }
        }
      })
      .state('tab.appointment-quicklogin', {
        url: '/appointment/quicklogin',
        views: {
          'tab-appointment': {
            templateUrl: 'templates/login/quicklogin.html',
            controller: 'QuickLoginCtrl'
          }
        }
      })
      .state('tab.appointment-register', {
        url: '/appointment/register',
        views: {
          'tab-appointment': {
            templateUrl: 'templates/login/register.html',
            controller: 'RegisterCtrl'
          }
        }
      })
      .state('tab.appointment-forgetpwd', {
        url: '/appointment/forgetpwd',
        views: {
          'tab-appointment': {
            templateUrl: 'templates/login/forget_pwd.html',
            controller: 'ForgetpwdCtrl'
          }
        }
      })
      .state('tab.publish', {
        cache: 'false',
        url: '/publish',
        views: {
          'tab-publish': {
            templateUrl: 'templates/user/publish.html',
            controller: 'PublishCtrl'
          }
        }
      })
      .state('tab.publish-new', {
        url: '/publish/new',
        views: {
          'tab-publish': {
            templateUrl: 'templates/user/publish_new.html',
            controller: 'PublishNewCtrl'
          }
        }
      })
      .state('tab.publish-city', {
        url: '/publish/city',
        views: {
          'tab-publish': {
            templateUrl: 'templates/common/city.html',
            controller: 'PublishCityCtrl'
          }
        }
      })
      .state('tab.publish-property', {
        url: '/publish/property',
        views: {
          'tab-publish': {
            templateUrl: 'templates/user/publish_search.html',
            controller: 'PublishPptCtrl'
          }
        }
      });
    $urlRouterProvider.otherwise('/tab/index');
    //if(window.JSON.parse(window.localStorage.getItem('slideBox'))){
    //  $urlRouterProvider.otherwise('/tab/index');
    //}else{
    //   window.localStorage.setItem('slideBox', window.JSON.stringify('true'));
    //   $urlRouterProvider.otherwise('/tab/slideBox');
    //}

    // if none of the above states are matched, use this as the fallback
  });