angular.module('starter.controllers', [])

  .controller('TabCtrl', function ($rootScope, $scope, $location, $state, $ionicHistory, $ionicTabsDelegate, Storage, CheckUserLogin, Variable, Public) {
    $rootScope.msgnum = Number(Storage.get('msgnum')) || 0;

    $scope.onTabSelected = function (tab) {
      CheckUserLogin();
      switch (tab) {
        case 'message':
          if (Storage.get('isPcUser')) {
            $state.go('tab.pcmessage', {}, {
              reload: true
            });
          } else if (Storage.get('fu_mobile')) {
            $state.go("tab.message", {}, {
              reload: true
            });
          } else {
            $location.url('/tab/message/quicklogin?source_url=/tab/message&back=true');
          }
          break;
        case 'appointment':
          if (Storage.get('isPcUser')) {
            $state.go("tab.pc-appt", {}, {
              reload: true
            });
          } else if (Storage.get('fu_mobile')) {
            $state.go("tab.user-appointment", {}, {
              reload: true
            });
          } else {
            $location.url('/tab/appointment/quicklogin?source_url=/tab/appointment&back=true');
          }
          break;
        case 'index':
          $state.go("tab.index", {}, {
            reload: true
          });
          break;
        case 'user':
          if (Storage.get('isPcUser')) {
            $location.path('/tab/pcuser');
          } else {
            $location.path('/tab/user');
          }
          break;
        case 'publish':
          $state.go("tab.publish", {}, {
            reload: true
          });
          break;
      }
      //			if (tab == 'index') {
      //			    StatusBar.overlaysWebView(true);
      //			} else {
      //			    StatusBar.overlaysWebView(false);
      //			    StatusBar.styleDefault();
      //			}
    };
  })
  //开机启动画面；
  //.controller('SlideBoxCtrl',function($scope,$location,$state,$ionicHistory,$ionicTabsDelegate,Storage){})
  //首页控制器
  //如果没有选择城市，跳到选择城市页面
  // device.model     :返回设备的模型或产品的名称
  // device.cordova  :返回cordova的版本
  // device.uuid        :返回手机 uuid
  // device.version   :返回系统版本
  // device.platform  :返回手机的平台信息  (android/ios 等等)
  .controller('IndexCtrl', function ($rootScope, $scope, $state, $ionicPopup, $http, $location, $cordovaGeolocation, $ionicLoading, $ionicModal, $cordovaInAppBrowser, $ionicPlatform, jpushService, Storage, Search, CheckUserLogin, Variable, Public) {
    $rootScope.msgnum = Number(Storage.get('msgnum')) || 0;
    console.log("---进入应用")
    if (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) {
      $scope.showProtocol = true;
      if (!Storage.get('protocol')) {
        console.log("---申请是否同意")
        var protocolPopup = $ionicPopup.show({
          template: '<p>欢迎您来到租房网！</p><p>请您仔细阅读以下条款，如果您对本协议的任何条款表示异议，您可以选择不进入租房网。</p><p>尊重和保护用户个人隐私是租房网的一项基本政策，租房网保证不对外公开或者向任何第三方提供单个用户的注册资料以及用户在使用网络服务时存储在租房网的非公开内容和信息。</p><p class="t-c">您可以阅读完整版<br><span style="color: #00a4ff;" ng-click="closeProtocolPopup();openLink(\'https://' + Variable.url + '/protocol?type=privacy\')">用户协议与隐私政策</span></p>',
          title: '温馨提示',
          cssClass: 'protocol-popup',
          scope: $scope,
          buttons: [{
            text: '不同意',
            onTap: function (e) {
              ionic.Platform.exitApp();
            }
          }, {
            text: '<b>同意</b>',
            type: 'button-balanced',
            onTap: function (e) {
              $scope.showProtocol = false;
              Storage.set('protocol', true);

              // 进行权限申请
              Public.initjpushService(jpushService);
              Public.readPhoneState();

              var myCity = new BMap.LocalCity();
              myCity.get(function (result) {
                var city = result.name.replace('市', '');

                if (city != '深圳') {
                  var confirmPopup = $ionicPopup.confirm({
                    title: '提示',
                    template: '当前城市为深圳，是否切换城市？',
                    okText: '切换',
                    cancelText: '取消'
                  });
                  confirmPopup.then(function (res) {
                    if (res) {
                      $location.path('/tab/index/city');
                    }
                  });
                }
              });
            }
          },]
        });
        var deregisterBackButton = $ionicPlatform.registerBackButtonAction(function (e) { }, 401);
        protocolPopup.then(function (res) {
          deregisterBackButton();
        });
        $scope.closeProtocolPopup = function () {
          protocolPopup.close();
        };
      } else {
        $scope.showProtocol = false;
      }
    } else if (!Storage.get('city_id')) {
      var myCity = new BMap.LocalCity();
      myCity.get(function (result) {
        var city = result.name.replace('市', '');

        if (city != '深圳') {
          var confirmPopup = $ionicPopup.confirm({
            title: '提示',
            template: '当前城市为深圳，是否切换城市？',
            okText: '切换',
            cancelText: '取消'
          });
          confirmPopup.then(function (res) {
            if (res) {
              $location.path('/tab/index/city');
            }
          });
        }
      });
    }

    if (!Storage.get('city_id')) {
      Storage.set('city_id', 3399);
      Storage.set('city_name', '深圳');
      Storage.set('ct_index', 'sz');
    }
    $scope.judgeUrl = function (url, type) {
      if (Storage.get('fu_mobile')) {
        Public.openLinkInApp(url);
      } else {
        $location.url('/tab/apart/quicklogin?source_url=' + url);
      }
    };

    $scope.openLink = function (url) {
      Public.openLinkInApp(url);
    };
    $scope.openLinkInSystem = function (url) {
      Public.openLinkInSystem(url);
    };

    $scope.openMessage = function () {
      CheckUserLogin();
      if (Storage.get('isPcUser')) {
        $state.go('tab.index-pcmessage', {}, {
          reload: true
        });
      } else if (Storage.get('fu_mobile')) {
        $state.go("tab.index-message", {}, {
          reload: true
        });
      } else {
        $location.url('/tab/apart/quicklogin?source_url=/tab/index');
      }
    };

    $scope.city_name = Storage.get('city_name');
    //获取regions(一天一次)
    var today = new Date();
    var hour = today.getHours();
    //  if(Storage.get('today') != today.toLocaleDateString()||!Storage.get('index_regions')){
    if (Storage.get('hour') != hour || !Storage.get('cityDataCache')) {
      Storage.set('hour', hour);
      //      Storage.set('today',today.toLocaleDateString());
      var myUrl = "https://" + Variable.url + "/index/getCityDataByIonic?cityid=" + Storage.get('city_id') + "&fu_app_id=" + Storage.get('fu_app_id') + "&callback=JSON_CALLBACK";
      if (Storage.get('protocol')) {
        $ionicLoading.show({
          template: '<ion-spinner icon="ios" class="popup-loading"></ion-spinner>',
          noBackdrop: true,
          duration: 5000
        });
      }
      $http.jsonp(myUrl, {
        cache: false
      }).success(
        function (ret) {
          $ionicLoading.hide();
          if (ret.code === 0) {
            console.log(ret.data);
            $scope.data = ret.data.rows;
            $scope.index_regions = ret.data.index_regions;
            $scope.rooms = ret.data.rooms;
            $scope.space = ret.data.space;
            $scope.region_data = ret.data.region_data;
            $scope.flat_data = ret.data.flat_data;
            Storage.set('hot_search', ret.data.hot_search);
            Storage.set('cityDataCache', ret.data.rows);
            Storage.set('rooms', ret.data.rooms);
            Storage.set('space', ret.data.space);
            Storage.set('index_regions', ret.data.index_regions);
            Storage.set('cityInfo', ret.data.city_info);
            Storage.set('region_data', ret.data.region_data);
            Storage.set('flat_data', ret.data.flat_data);
          } else {
            $ionicPopup.alert({
              title: '提示',
              template: ret.msg
            });
          }
        }
      ).error(function (err) {
        console.log('err:' + err);
      });
    } else {
      $scope.data = Storage.get('cityDataCache');
      $scope.index_regions = Storage.get('index_regions');
      $scope.rooms = Storage.get('rooms');
      $scope.space = Storage.get('space');
      $scope.region_data = Storage.get('region_data');
      $scope.flat_data = Storage.get('flat_data');
    }
  })
  //页面搜索；
  .controller('SearchCtrl', function ($scope, $http, $location, Storage, Public, Variable) {
    if (!Storage.get('city_id')) {
      $location.path('/tab/index/city');
    } else {
      $scope.hot_search = Storage.get('hot_search');
      //首页搜索：
      //首页搜索：
      var att_type_arr = [{
        id: 1,
        name: '租房'
      },
      {
        id: 2,
        name: '写字楼'
      }
      ];

      $scope.formData = {};
      $scope.formData.apt_type = 1;
      $scope.keyword = '';
      $scope.type = '';
      $scope.att_type_arr = att_type_arr;
      $scope.sendKeyword = function (keyword) {
        $scope.keyword = keyword;
        var myUrl = "https://" + Variable.url + "/client/search/search/getTipsByIonic?cityid=" + Storage.get('city_id') + "&keyword=" + encodeURI(keyword) + "&callback=JSON_CALLBACK";
        $http.jsonp(myUrl).success(
          function (ret) {
            $scope.drop_tips = ret;
            if (ret != null && ret.length != 0) {
              $('.drop-tips-wrap').addClass('minHeight');
            } else {
              $('.drop-tips-wrap').removeClass('minHeight');
            }
          }
        ).error(function (err) {
          console.log('err:' + err);
        });
      };
      $scope.search = function (val, type) {
        var keyword = val || $scope.keyword;
        var type = type || $scope.type;
        if (1 == $scope.formData.apt_type) {
          $http.jsonp('https://' + Variable.url + '/client/search/search/keySearchByIonic?cityid=' + Storage.get('city_id') + '&addr=' + encodeURI(keyword) + '&kh_type=' + type + '&url=/' + Storage.get("ct_index") + '/list/1&callback=JSON_CALLBACK ').success(
            function (ret) {
              Public.openLinkInApp(ret);
            }
          );
        } else {
          $http.jsonp('https://' + Variable.url + '/client/search/officeSearch/keySearchByIonic?cityid=' + Storage.get('city_id') + '&addr=' + encodeURI(keyword) + '&kh_type=' + type + '&url=/' + Storage.get("ct_index") + '/officelist/1&callback=JSON_CALLBACK ').success(
            function (ret) {
              Public.openLinkInApp(ret);
            }
          );
        }
      };
    }

  })
  //选择城市页面控制
  .controller('IndexCityCtrl', function ($rootScope, $scope, $http, $location, $cordovaGeolocation, Storage, Search, Variable) {
    if (!Storage.get('city_id')) {
      Storage.set('city_id', 3399);
      Storage.set('city_name', '深圳');
      Storage.set('ct_index', 'sz');
    }
    //  $scope.current_city = '正在定位...';
    //  $scope.current_city_id = '';
    //
    //  var posOptions = {timeout: 10000, enableHighAccuracy: false};
    //  $cordovaGeolocation
    //    .getCurrentPosition(posOptions)
    //    .then(function (position) {
    //      var lat = position.coords.latitude,
    //          lng = position.coords.longitude;
    //
    //      var point = new BMap.Point(lng, lat); // 创建点坐标
    //      var gc = new BMap.Geocoder();
    //
    //      gc.getLocation(point, function(rs) {
    //          var addComp = rs.addressComponents;
    //          var city = addComp.city.replace('市', '');
    //
    //          $scope.$apply(function () {
    //              $scope.current_city = city;
    //          });
    //          angular.forEach(Search.citys,function(data){
    //              if(data.name == city){
    //                  $scope.current_city_id = data.id;
    //                  $scope.current_city_index = data.ct_index;
    //              }
    //          });
    //      });
    //    }, function(err) {
    //      $scope.current_city = '定位失败，请开启定位后重试';
    //  });

    //设置城市id
    $scope.set_city_id = function (id, name, ct_index) {
      if ($scope.current_city_id !== '' && 'current' == id) {
        id = $scope.current_city_id;
        name = $scope.current_city;
        ct_index = $scope.current_city_index;
      }

      if ('current' != id && id && name) {
        Storage.clearCity(); //清除缓存

        // 设置城市id、城市名字;
        Storage.set('city_id', id);
        Storage.set('city_name', name);
        Storage.set('ct_index', ct_index);

        $location.path('/tab/index');
      }
    };

    if (!$rootScope.cities) {
      var url = "https://" + Variable.url + "/getCityInfo?callback=JSON_CALLBACK";
      $http.jsonp(url).success(
        function (ret) {
          $rootScope.cities = ret;
        }
      );
    }
  })
  /*
  注册、登录、找回密码
  */
  //登录
  .controller('LoginCtrl', function ($rootScope, $scope, $http, $location, $ionicPopup, $ionicLoading, $timeout, Storage, ShowTopTip, Variable, Md5, Public) {
    //		if($location.search().back) {
    //			$scope.hideTabs = false;
    //		} else {
    //			$scope.hideTabs = true;
    //		}

    //如果没有选择城市，跳到选择城市页面
    if (!Storage.get('city_id')) {
      $location.path('/tab/index/city');
    } else {
      //页面url
      var source_url = $location.search().source_url || '/tab/user',
        fu_mobile = $location.search().fu_mobile,
        apartment_id = $location.search().apartment_id,
        apt_type = $location.search().apt_type;
      $scope.register_url = $location.url().replace('login', 'register');
      $scope.forget_url = $location.url().replace('login', 'forgetpwd');

      $scope.formData = {};
      $scope.formData.fu_mobile = fu_mobile || Storage.get('own_number');
      $scope.processForm = function () {
        if ($scope.formData.fu_mobile < 10000000000 || $scope.formData.fu_mobile > 99999999999 || !$scope.formData.fu_mobile) {
          ShowTopTip("请输入正确的手机号");

          return false;
        }

        if (!$scope.formData.password || $scope.formData.password.length < 6) {
          ShowTopTip("请输入正确的密码");

          return false;
        }

        if (!$scope.formData.pic_code || $scope.formData.pic_code.length != 4) {
          ShowTopTip("请输入正确的图形验证码");

          return false;
        }
        $ionicLoading.show({
          template: '<ion-spinner icon="ios" class="popup-loading"></ion-spinner>',
          noBackdrop: true,
          duration: 5000
        });
        var data = {
          source: 'zufun',
          fu_password: Md5.set($scope.formData.password),
          pic_code: $scope.formData.pic_code,
          fu_mobile: $scope.formData.fu_mobile,
          fu_app_id: Storage.get('fu_app_id')
        };
        var login_url = "https://" + Variable.url + "/client/memMng/memLogin/loginByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
        $http.jsonp(login_url).success(
          function (ret) {
            $ionicLoading.hide();
            if (ret.code === 0) {
              Storage.set('fu_mobile', ret.data.fu_mobile);
              Storage.set('fu_name', ret.data.fu_name);
              Storage.set('msgnum', ret.data.msgnum);
              //设置消息数量
              $rootScope.msgnum = Number(ret.data.msgnum) || 0;

              //预约看房；
              if (apartment_id) {
                var data = {
                  apartment_id: apartment_id,
                  fu_mobile: $scope.formData.fu_mobile,
                  apt_type: apt_type,
                  fu_app_id: Storage.get('fu_app_id')
                };
                Public.addAppointment(data, function (ret) {
                  switch (Number(ret.code)) {
                    case 1: //报错
                      ShowTopTip(ret.msg);
                      break;
                    case 3: //已预约
                    case 4: //未预约、未关注
                    case 5: //未预约、已关注
                      $location.url(source_url + '?appt_code=' + ret.code + '&mem_appointment_id=' + ret.data);
                      break;
                  }
                });
              } else {
                $location.url(source_url);
              }
            } else {
              $ionicPopup.alert({
                title: '提示',
                template: ret.msg
              });
              $scope.get_pic_code();
            }
          }
        );
      };

      //图片验证码
      var pic_url = "https://" + Variable.url + "/client/memMng/memLogin/getPiccodeByIonic?callback=JSON_CALLBACK";
      $scope.get_pic_code = function () {
        $http.jsonp(pic_url).success(
          function (ret) {
            if (ret.code === 0) {
              $scope.pic_src = ret.data;
            } else {
              alert(ret.msg);
            }
          }
        ).error(function (err) {
          console.log('err:' + err);
        });
      };
      $scope.get_pic_code();
    }
  })
  //快捷登录
  .controller('QuickLoginCtrl', function ($rootScope, $scope, $http, $ionicLoading, $location, $ionicPopup, $interval, Storage, ShowTopTip, Variable, Md5, Public) {
    if ($location.search().back) {
      $scope.hideTabs = false;
    } else {
      $scope.hideTabs = true;
    }

    $scope.url = $location.url().replace('quicklogin', 'login');

    //如果没有选择城市，跳到选择城市页面
    if (!Storage.get('city_id')) {
      $location.path('/tab/index/city');
    } else {
      //页面url
      var source_url = $location.search().source_url || '/tab/user',
        fu_mobile = $location.search().fu_mobile;
      //页面url
      $scope.login_url = $location.url().replace('register', 'login');

      $scope.formData = {};
      $scope.formData.fu_mobile = fu_mobile || Storage.get('own_number');
      $scope.processForm = function () {
        if ($scope.formData.fu_mobile < 10000000000 || $scope.formData.fu_mobile > 99999999999 || !$scope.formData.fu_mobile) {
          ShowTopTip("请输入正确的手机号");

          return false;
        }

        if (!$scope.formData.vcode || $scope.formData.vcode.length != 6) {
          ShowTopTip("请输入正确的短信验证码");

          return false;
        }

        $ionicLoading.show({
          template: '<ion-spinner icon="ios" class="popup-loading"></ion-spinner>',
          noBackdrop: true,
          duration: 5000
        });
        var data = {
          source: 'zufun',
          fu_app_id: Storage.get('fu_app_id'),
          fu_mobile: $scope.formData.fu_mobile,
          vcode: $scope.formData.vcode
        };
        var url = "https://" + Variable.url + "/client/memMng/memLogin/registerMemberByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
        $http.jsonp(url).success(
          function (ret) {
            $ionicLoading.hide();
            if (ret.code === 0) {

              Storage.set('fu_mobile', ret.data.fu_mobile);
              Storage.set('fu_name', ret.data.fu_name);
              Storage.set('msgnum', ret.data.msgnum);
              //设置消息数量
              $rootScope.msgnum = Number(ret.data.msgnum) || 0;

              $location.path(source_url);
            } else if (ret.code === 'ERR_PICCODE') {
              $scope.showRequiredError = true;
              $scope.get_pic_code();
              setTimeout(function () {
                $ionicPopup.show({
                  template: '<div class="form-group"><div class="form-group-inupt"><input ng-model="smsData.pic_code" name="pic_code" type="tel" autofocus style="padding-right:65px; padding-left:5px;"></div><div id="pic_code" class="pic-code" ng-click="get_pic_code();" ><img src="{{pic_src}}" width="100" height="35" style="border:0;"></div></div>',
                  title: '请输入图形验证码',
                  scope: $scope,
                  buttons: [{
                    text: '取消'
                  }, {
                    text: '<b>确定</b>',
                    type: 'button-balanced',
                    onTap: function (e) {
                      if ($scope.smsData.pic_code) {
                        var data = {
                          source: 'zufun',
                          fu_app_id: Storage.get('fu_app_id'),
                          fu_mobile: $scope.formData.fu_mobile,
                          vcode: $scope.formData.vcode,
                          pic_code: $scope.smsData.pic_code
                        };
                        var url = "https://" + Variable.url + "/client/memMng/memLogin/registerMemberByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
                        $http.jsonp(url).success(
                          function (ret) {
                            if (ret.code === 0) {
                              Storage.set('fu_mobile', ret.data.fu_mobile);
                              Storage.set('fu_name', ret.data.fu_name);
                              Storage.set('msgnum', ret.data.msgnum);
                              //设置消息数量
                              $rootScope.msgnum = Number(ret.data.msgnum) || 0;

                              $location.path(source_url);
                            } else {
                              $ionicPopup.alert({
                                title: '提示',
                                template: ret.msg
                              });
                            }
                          }
                        );
                      } else {
                        alert("请输入图形验证码");
                        return false;
                      }
                    }
                  },]
                });
              }, 300);
            } else {
              $ionicPopup.alert({
                title: '提示',
                template: ret.msg
              });
            }
          }
        );
      };

      /**
       * 判断控制；发送验证码的按钮文字颜色；
       */
      $scope.$watch('formData.fu_mobile', function (newValue, oldValue) {
        if (newValue) {
          if (newValue.length == 11) {
            $scope.paraclass = '';
          } else {
            $scope.paraclass = 'c-gray';
          }
        }
      });

      //发送验证码
      $scope.paracont = '获取验证码';
      $scope.paraclass = 'c-gray';
      $scope.paraevent = true;
      var countDown = function () {
        var second = 30,
          timePromise;

        timePromise = $interval(function () {
          if (second <= 0) {
            $interval.cancel(timePromise);
            timePromise = '';
            second = 30;
            $scope.paracont = '获取验证码';
            $scope.paraclass = '';
            $scope.paraevent = true;
          } else {
            $scope.paracont = '重新发送(' + second + ')';
            $scope.paraclass = 'c-gray';
            second--;
          }
        }, 1000, 100);
      };
      $scope.smsData = {};
      $scope.sendVcode = function () {
        if ($scope.formData.fu_mobile < 10000000000 || $scope.formData.fu_mobile > 99999999999 || !$scope.formData.fu_mobile) {
          ShowTopTip("请输入正确的手机号");

          return false;
        }

        if ($scope.paraclass == 'c-gray') {
          return false;
        }

        $scope.showRequiredError = true;
        $scope.get_pic_code();
        setTimeout(function () {
          $ionicPopup.show({
            template: '<div class="form-group"><div class="form-group-inupt"><input ng-model="smsData.pic_code" name="pic_code" type="tel" autofocus style="padding-right:65px; padding-left:5px;"></div><div id="pic_code" class="pic-code" ng-click="get_pic_code();" ><img src="{{pic_src}}" width="100" height="35" style="border:0;"></div></div>',
            title: '请输入图形验证码',
            scope: $scope,
            buttons: [{
              text: '取消'
            }, {
              text: '<b>确定</b>',
              type: 'button-balanced',
              onTap: function (e) {
                if ($scope.smsData.pic_code) {
                  var data = {
                    fu_mobile: $scope.formData.fu_mobile,
                    pic_code: $scope.smsData.pic_code,
                    type: 'appoint'
                  };
                  var url = "https://" + Variable.url + "/client/memMng/memLogin/sendSmsForRegByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
                  $http.jsonp(url).success(
                    function (ret) {
                      if (ret.code === 0) {
                        countDown(); //倒计时
                      } else {
                        ShowTopTip(ret.msg);
                        $scope.get_pic_code();
                      }
                    }
                  );
                } else {
                  alert("请输入图形验证码");
                  return false;
                }
              }
            },]
          });
        }, 300);
      };

      //图片验证码
      var pic_url = "https://" + Variable.url + "/client/memMng/memLogin/getPiccodeByIonic?callback=JSON_CALLBACK";
      $scope.get_pic_code = function () {
        $http.jsonp(pic_url).success(
          function (ret) {
            if (ret.code === 0) {
              $scope.pic_src = ret.data;
            } else {
              ShowTopTip(ret.msg);
            }
          }
        ).error(function (err) {
          console.log('err:' + err);
        });
      };
    }
  })
  //注册页面；
  .controller('RegisterCtrl', function ($rootScope, $scope, $http, $ionicLoading, $location, $ionicPopup, $interval, Storage, ShowTopTip, Variable, Md5, Public) {
    //如果没有选择城市，跳到选择城市页面
    if (!Storage.get('city_id')) {
      $location.path('/tab/index/city');
    } else {
      //页面url
      var source_url = $location.search().source_url || '/tab/user',
        fu_mobile = $location.search().fu_mobile;
      //页面url
      $scope.login_url = $location.url().replace('register', 'login');

      $scope.formData = {};
      $scope.formData.fu_mobile = fu_mobile || Storage.get('own_number');
      $scope.processForm = function () {
        if ($scope.formData.fu_mobile < 10000000000 || $scope.formData.fu_mobile > 99999999999 || !$scope.formData.fu_mobile) {
          ShowTopTip("请输入正确的手机号");

          return false;
        }

        if (!$scope.formData.vcode || $scope.formData.vcode.length != 6) {
          ShowTopTip("请输入正确的短信验证码");

          return false;
        }

        if (!$scope.formData.password || $scope.formData.password.length < 6) {
          ShowTopTip("请输入正确的密码");

          return false;
        }
        $ionicLoading.show({
          template: '<ion-spinner icon="ios" class="popup-loading"></ion-spinner>',
          noBackdrop: true,
          duration: 5000
        });
        var data = {
          source: "zufun",
          fu_app_id: Storage.get('fu_app_id'),
          fu_mobile: $scope.formData.fu_mobile,
          fu_password: Md5.set($scope.formData.password),
          vcode: $scope.formData.vcode
        };
        var url = "https://" + Variable.url + "/client/memMng/memLogin/registerMemberByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
        $http.jsonp(url).success(
          function (ret) {
            $ionicLoading.hide();
            if (ret.code === 0) {

              Storage.set('fu_mobile', ret.data.fu_mobile);
              Storage.set('fu_name', ret.data.fu_name);
              Storage.set('msgnum', ret.data.msgnum);
              //设置消息数量
              $rootScope.msgnum = Number(ret.data.msgnum) || 0;

              $location.path(source_url);
            } else if (ret.code === 'ERR_PICCODE') {
              $scope.showRequiredError = true;
              $scope.get_pic_code();
              setTimeout(function () {
                $ionicPopup.show({
                  template: '<div class="form-group"><div class="form-group-inupt"><input ng-model="smsData.pic_code" name="pic_code" type="tel" autofocus style="padding-right:65px; padding-left:5px;"></div><div id="pic_code" class="pic-code" ng-click="get_pic_code();" ><img src="{{pic_src}}" width="100" height="35" style="border:0;"></div></div>',
                  title: '请输入图形验证码',
                  scope: $scope,
                  buttons: [{
                    text: '取消'
                  }, {
                    text: '<b>确定</b>',
                    type: 'button-balanced',
                    onTap: function (e) {
                      if ($scope.smsData.pic_code) {
                        var data = {
                          source: "zufun",
                          fu_app_id: Storage.get('fu_app_id'),
                          fu_mobile: $scope.formData.fu_mobile,
                          fu_password: Md5.set($scope.formData.password),
                          vcode: $scope.formData.vcode,
                          pic_code: $scope.smsData.pic_code
                        };
                        var url = "https://" + Variable.url + "/client/memMng/memLogin/registerMemberByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
                        $http.jsonp(url).success(
                          function (ret) {
                            if (ret.code === 0) {
                              Storage.set('fu_mobile', ret.data.fu_mobile);
                              Storage.set('fu_name', ret.data.fu_name);
                              Storage.set('msgnum', ret.data.msgnum);
                              //设置消息数量
                              $rootScope.msgnum = Number(ret.data.msgnum) || 0;

                              $location.path(source_url);
                            } else {
                              $ionicPopup.alert({
                                title: '提示',
                                template: ret.msg
                              });
                            }
                          }
                        );
                      } else {
                        alert("请输入图形验证码");
                        return false;
                      }
                    }
                  },]
                });
              }, 300);
            } else {
              $ionicPopup.alert({
                title: '提示',
                template: ret.msg
              });
            }
          }
        );
      };

      /**
       * 判断控制；发送验证码的按钮文字颜色；
       */
      $scope.$watch('formData.fu_mobile', function (newValue, oldValue) {
        if (newValue) {
          if (newValue.length == 11) {
            $scope.paraclass = '';
          } else {
            $scope.paraclass = 'c-gray';
          }
        }
      });

      //发送验证码
      $scope.paracont = '获取验证码';
      $scope.paraclass = 'c-gray';
      $scope.paraevent = true;
      var countDown = function () {
        var second = 30,
          timePromise;

        timePromise = $interval(function () {
          if (second <= 0) {
            $interval.cancel(timePromise);
            timePromise = '';
            second = 30;
            $scope.paracont = '获取验证码';
            $scope.paraclass = '';
            $scope.paraevent = true;
          } else {
            $scope.paracont = '重新发送(' + second + ')';
            $scope.paraclass = 'c-gray';
            second--;
          }
        }, 1000, 100);
      };
      $scope.smsData = {};
      $scope.sendVcode = function () {
        if ($scope.formData.fu_mobile < 10000000000 || $scope.formData.fu_mobile > 99999999999 || !$scope.formData.fu_mobile) {
          ShowTopTip("请输入正确的手机号");

          return false;
        }

        if ($scope.paraclass == 'c-gray') {
          return false;
        }

        $scope.showRequiredError = true;
        $scope.get_pic_code();
        setTimeout(function () {
          $ionicPopup.show({
            template: '<div class="form-group"><div class="form-group-inupt"><input ng-model="smsData.pic_code" name="pic_code" type="tel" autofocus style="padding-right:65px; padding-left:5px;"></div><div id="pic_code" class="pic-code" ng-click="get_pic_code();" ><img src="{{pic_src}}" width="100" height="35" style="border:0;"></div></div>',
            title: '请输入图形验证码',
            scope: $scope,
            buttons: [{
              text: '取消'
            }, {
              text: '<b>确定</b>',
              type: 'button-balanced',
              onTap: function (e) {
                if ($scope.smsData.pic_code) {
                  var data = {
                    fu_mobile: $scope.formData.fu_mobile,
                    pic_code: $scope.smsData.pic_code
                  };
                  var url = "https://" + Variable.url + "/client/memMng/memLogin/sendSmsForRegByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
                  $http.jsonp(url).success(
                    function (ret) {
                      if (ret.code === 0) {
                        countDown(); //倒计时
                      } else {
                        ShowTopTip(ret.msg);
                        $scope.get_pic_code();
                      }
                    }
                  );
                } else {
                  alert("请输入图形验证码");
                  return false;
                }
              }
            },]
          });
        }, 300);
      };

      //图片验证码
      var pic_url = "https://" + Variable.url + "/client/memMng/memLogin/getPiccodeByIonic?callback=JSON_CALLBACK";
      $scope.get_pic_code = function () {
        $http.jsonp(pic_url).success(
          function (ret) {
            if (ret.code === 0) {
              $scope.pic_src = ret.data;
            } else {
              ShowTopTip(ret.msg);
            }
          }
        ).error(function (err) {
          console.log('err:' + err);
        });
      };

    }
  })
  //忘记密码
  .controller('ForgetpwdCtrl', function ($rootScope, $scope, $http, $location, $ionicLoading, $interval, $ionicPopup, ShowTopTip, Storage, Variable, Md5, Public) {
    //如果没有选择城市，跳到选择城市页面
    if (!Storage.get('city_id')) {
      $location.path('/tab/index/city');
    } else {
      var source_url = $location.search().source_url || '/tab/user';
      $scope.formData = {};
      $scope.formData.fu_mobile = Storage.get('own_number');
      $scope.processForm = function () {
        if ($scope.formData.fu_mobile < 10000000000 || $scope.formData.fu_mobile > 99999999999 || !$scope.formData.fu_mobile) {
          ShowTopTip("请输入正确的手机号");

          return false;
        }

        if (!$scope.formData.fu_vcode || $scope.formData.fu_vcode.length != 6) {
          ShowTopTip("请输入正确的短信验证码");

          return false;
        }

        if (!$scope.formData.password || $scope.formData.password.length < 6) {
          ShowTopTip("请输入正确的密码");

          return false;
        }
        $ionicLoading.show({
          template: '<ion-spinner icon="ios" class="popup-loading"></ion-spinner>',
          noBackdrop: true,
          duration: 5000
        });
        var data = {
          fu_mobile: $scope.formData.fu_mobile,
          newpwd: Md5.set($scope.formData.password),
          fu_app_id: Storage.get('fu_app_id'),
          fu_vcode: $scope.formData.fu_vcode
        };
        var url = "https://" + Variable.url + "/client/memMng/memLogin/modifyPwdByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
        $http.jsonp(url).success(
          function (ret) {
            $ionicLoading.hide();
            if (ret.code === 0) {
              Storage.set('fu_mobile', ret.data.fu_mobile);
              Storage.set('fu_name', ret.data.fu_name);
              Storage.set('msgnum', ret.data.msgnum);

              //设置消息数量
              $rootScope.msgnum = Number(ret.data.msgnum) || 0;

              $location.path(source_url);
            } else {
              ShowTopTip(ret.msg);
            }
          }
        );
      };

      //发送手机验证码
      //发送验证码
      $scope.paracont = '获取验证码';
      $scope.paraclass = 'c-gray';
      $scope.paraevent = true;
      var countDown = function () {
        var second = 30,
          timePromise;

        timePromise = $interval(function () {
          if (second <= 0) {
            $interval.cancel(timePromise);
            timePromise = '';
            second = 30;
            $scope.paracont = '发送验证码';
            $scope.paraclass = '';
            $scope.paraevent = true;
          } else {
            $scope.paracont = '重新发送(' + second + ')';
            $scope.paraclass = 'c-gray';
            second--;
          }
        }, 1000, 100);
      };
      $scope.smsData = {};
      $scope.sendVcode = function () {
        if ($scope.formData.fu_mobile < 10000000000 || $scope.formData.fu_mobile > 99999999999 || !$scope.formData.fu_mobile) {
          ShowTopTip("请输入正确的手机号");

          return false;
        }

        if ($scope.paraclass == 'c-gray') {
          return false;
        }

        $scope.get_pic_code();
        setTimeout(function () {
          $ionicPopup.show({
            template: '<div class="form-group"><div class="form-group-inupt"><input ng-model="smsData.pic_code" name="pic_code" type="tel" autofocus style="padding-right:65px; padding-left:5px;"></div><div id="pic_code" class="pic-code" ng-click="get_pic_code();" ><img src="{{pic_src}}" width="100" height="35" style="border:0;"></div></div>',
            title: '请输入图形验证码',
            scope: $scope,
            buttons: [{
              text: '取消'
            }, {
              text: '<b>确定</b>',
              type: 'button-balanced',
              onTap: function (e) {
                if ($scope.smsData.pic_code) {
                  var data = {
                    fu_mobile: $scope.formData.fu_mobile,
                    pic_code: $scope.smsData.pic_code
                  };
                  var url = "https://" + Variable.url + "/client/memMng/memLogin/sendSmsForForgetPwdByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
                  $http.jsonp(url).success(
                    function (ret) {
                      if (ret.code === 0) {
                        countDown(); //倒计时
                      } else {
                        ShowTopTip(ret.msg);
                        $scope.get_pic_code();
                      }
                    }
                  );
                } else {
                  ShowTopTip('请输入图形验证码');
                  return false;
                }
              }
            },]
          });
        }, 300);
      };

      /**
       * 判断控制；发送验证码的按钮文字颜色；
       */
      $scope.$watch('formData.fu_mobile', function (newValue, oldValue) {
        if (newValue) {
          if (newValue.length == 11) {
            $scope.paraclass = '';
          } else {
            $scope.paraclass = 'c-gray';
          }
        }
      });

      //图片验证码
      var pic_url = "https://" + Variable.url + "/client/memMng/memLogin/getPiccodeByIonic?callback=JSON_CALLBACK";
      $scope.get_pic_code = function () {
        $http.jsonp(pic_url).success(
          function (ret) {
            if (ret.code === 0) {
              $scope.pic_src = ret.data;
            } else {
              ShowTopTip(ret.msg);
            }
          }
        ).error(function (err) {
          console.log('err:' + err);
        });
      };

    }
  })
  /*
  个人中心。
  个人信息、
  我的优惠、
  消息中心、
  关注房源、
  关注楼盘、
  我的预约、
  出租房源、
  二手房源、
  我的合约
  */
  //物业首页；
  .controller('PcUserCtrl', function ($scope, $location, Storage, Public, Variable) {

    $scope.judgeUrl = function (url) {
      Public.openLinkInApp('https://' + Variable.url + url);
    };

  })
  //个人中心首页
  .controller('UserIndexCtrl', function ($rootScope, $scope, $location, Storage, Public, Variable) {
    $scope.judgeUrl = function (url, type) {
      if (Storage.get('fu_mobile')) {
        Public.openLinkInApp(url);
      } else {
        $location.path('/tab/quicklogin');
      }
    };
    $scope.openLink = function (url) {
      Public.openLinkInApp('https://' + Variable.url + url);
    };
    $rootScope.feedbacknum = Storage.get("feedbacknum");
    $rootScope.kf_mobile = String(Storage.get("kf_mobile") || '132-6682-1881').replace(/-/g, '');
  })
  /*物业消息*/
  .controller('PcMessageCtrl', function ($rootScope, $scope, $http, $location, $ionicPopup, $sce, $ionicLoading, Storage, Jsonp, Public, Variable) {
    $ionicLoading.show({
      template: '<ion-spinner icon="ios" class="popup-loading"></ion-spinner>',
      noBackdrop: true,
      duration: 5000
    });
    var getMessageData = function (page) {
      var data = {
        fu_app_id: Storage.get('fu_app_id'),
        page: page
      };
      var url = "https://" + Variable.url + "/admin/property/propSysMsg/getSysMsgByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
      $http.jsonp(url, {
        cache: false
      }).success(
        function (ret) {
          if (ret.code === 0) {
            if (1 != page) {
              if (ret.data.rows && $scope.data) {
                angular.forEach(ret.data.rows, function (value, index) {
                  $scope.data.push(value);
                });
                if (ret.data.rows.length < 10) {
                  $scope.vm.moredata = true;
                } else {
                  $scope.$broadcast('scroll.infiniteScrollComplete');
                }
              } else {
                $scope.vm.moredata = true;
              }
            } else {
              $ionicLoading.hide();
              $scope.data = ret.data.rows;
            }
          } else {
            $scope.vm.moredata = true;
            $ionicPopup.alert({
              title: '提示',
              template: ret.msg
            });
          }
        }
      );
    };
    var vm = $scope.vm = {
      moredata: false,
      messages: [],
      pagination: {
        perPage: 5,
        currentPage: 1
      },
      init: function () {
        getMessageData(1);
      },
      show: function (message) {
        if (message.static) {
          message.static = false;
        } else {
          message.static = true;
        }
      },
      loadMore: function () {
        vm.pagination.currentPage += 1;
        var page = vm.pagination.currentPage;
        getMessageData(page);
      }
    };
    vm.init();

    //打开链接；
    $scope.openLink = function (url) {
      Public.openLinkInApp(url);
    };
    $scope.messageDetail = function (index, readStatus) {
      if ($scope.data[index].showDetail) {
        $scope.data[index].showDetail = false;
      } else {
        $scope.data[index].showDetail = true;
      }
      if (!$scope.data[index]['detail']) {
        var data = {
          fu_app_id: Storage.get('fu_app_id'),
          prop_sysmsg_id: $scope.data[index].prop_sysmsg_id,
          psrs_status: $scope.data[index].psrs_status,
          prop_sysmsg_detail_id: $scope.data[index].prop_sysmsg_detail_id
        };
        var url = "https://" + Variable.url + "/admin/property/propSysMsg/getSysMsgDetailByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
        $http.jsonp(url).success(
          function (ret) {
            if (ret.code === 0) {
              var data = ret.data;
              if (ret.data.indexOf('href="/platform/appointment"') > -1) {
                data = data.replace('/platform/appointment', '#/tab/pcappt');
              } else if (ret.data.indexOf('href="/platform/esfApartment"') > -1) {
                data = data.replace('href="/platform/esfApartment"', 'ng-click="openLink(\'https://' + Variable.url + '/platform/esfApartment\')"');
              } else if (ret.data.indexOf('href="/platform/apartment"') > -1) {
                data = data.replace('href="/platform/apartment"', 'ng-click="openLink(\'https://' + Variable.url + '/platform/apartment\')"');
              } else if (ret.data.indexOf('href="/platform/property"') > -1) {
                data = data.replace('href="/platform/property"', 'ng-click="openLink(\'https://' + Variable.url + '/platform/property\')"');
              }

              $scope.data[index]['detail'] = data;
            } else {
              $ionicPopup.alert({
                title: '提示',
                template: ret.msg
              });
            }
          }
        );
      }

      //处理消息数量；
      if (2 != $scope.data[index].psrs_status) {
        var msgnum = Number(Storage.get('msgnum'));
        msgnum--;
        $rootScope.msgnum = msgnum;
        Storage.set('msgnum', msgnum);
        $scope.data[index].psrs_status = 2; // 设为已读；
      }
    };
  })
  //系统消息
  .controller('UserMessageCtrl', function ($rootScope, $scope, $http, $location, $ionicPopup, $sce, $ionicLoading, Storage, Jsonp, Public, Variable) {
    if (Storage.get('fu_mobile')) {
      var getMessageData = function (page) {
        var data = {
          fu_app_id: Storage.get('fu_app_id'),
          page: page
        };
        var url = "https://" + Variable.url + "/client/memMng/memSysMsg/getSysMsgByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
        $http.jsonp(url, {
          cache: false
        }).success(
          function (ret) {
            if (ret.code === 0) {
              if (1 != page) {
                if (ret.data.rows && $scope.data) {
                  angular.forEach(ret.data.rows, function (value, index) {
                    $scope.data.push(value);
                  });
                  if (ret.data.rows.length < 10) {
                    $scope.vm.moredata = true;
                  } else {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                  }
                } else {
                  $scope.vm.moredata = true;
                }
              } else {
                $scope.data = ret.data.rows;
              }
            } else {
              $scope.vm.moredata = true;
              $ionicPopup.alert({
                title: '提示',
                template: ret.msg
              });
            }
          }
        );
      };
      var vm = $scope.vm = {
        moredata: false,
        messages: [],
        pagination: {
          perPage: 5,
          currentPage: 1
        },
        init: function () {
          getMessageData(1);
        },
        show: function (message) {
          if (message.static) {
            message.static = false;
          } else {
            message.static = true;
          }
        },
        loadMore: function () {
          vm.pagination.currentPage += 1;
          var page = vm.pagination.currentPage;
          getMessageData(page);
        }
      };
      vm.init();

      //打开链接；
      $scope.openLink = function (url) {
        Public.openLinkInApp(url);
      };
      $scope.messageDetail = function (index, readStatus) {
        if ($scope.data[index].showDetail) {
          $scope.data[index].showDetail = false;
        } else {
          $scope.data[index].showDetail = true;
        }
        if (!$scope.data[index]['detail']) {
          var data = {
            fu_app_id: Storage.get('fu_app_id'),
            sys_pubmsg_detail_id: $scope.data[index].sys_pubmsg_detail_id,
            sp_read_status: $scope.data[index].sp_read_status,
            sys_pubmsg_id: $scope.data[index].sys_pubmsg_id
          };
          var url = "https://" + Variable.url + "/client/memMng/memSysMsg/getSysMsgDetailByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
          $http.jsonp(url).success(
            function (ret) {
              if (ret.code === 0) {
                var data = ret.data;

                if (ret.data.indexOf('href="/user/appointment"') > -1) {
                  data = data.replace('/user/appointment', '#/tab/appointment');
                } else if (ret.data.indexOf('href="/user/zf/apt/index"') > -1) {
                  data = data.replace('href="/user/zf/apt/index"', 'ng-click="openLink(\'user/esf/apt/index\')"');
                } else if (ret.data.indexOf('href="/user/esf/apt/index"') > -1) {
                  data = data.replace('href="/user/esf/apt/index"', 'ng-click="openLink(\'user/esf/apt/index\')"');
                }

                $scope.data[index]['detail'] = data;
              } else {
                $ionicPopup.alert({
                  title: '提示',
                  template: ret.msg
                });
              }
            }
          );
        }

        //处理消息数量；
        if (2 != $scope.data[index].sp_read_status) {
          var msgnum = Number(Storage.get('msgnum'));
          msgnum--;
          $rootScope.msgnum = msgnum;
          Storage.set('msgnum', msgnum);
          $scope.data[index].sp_read_status = 2; // 设为已读；
        }
      };
    } else {
      $location.url('/tab/message/quicklogin?source_url=/tab/message');
    }
  })
  // 物业后台，我的预约；
  .controller('PcApptCtrl', function ($scope, $http, $location, $ionicPopup, $ionicLoading, $stateParams, Storage, Variable, Public) {
    var getMessageData = function (page) {
      var data = {
        fu_app_id: Storage.get('fu_app_id'),
        page: page
      };
      var url = "https://" + Variable.url + "/admin/property/appointMng/getAppointmentsByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
      $http.jsonp(url, {
        cache: false
      }).success(
        function (ret) {
          if (ret.code === 0) {
            if (1 != page) {
              if (ret.data.rows && $scope.data) {
                angular.forEach(ret.data.rows, function (value, index) {
                  $scope.data.push(value);
                });
                if (ret.data.rows.length < 10) {
                  $scope.vm.moredata = true;
                } else {
                  $scope.$broadcast('scroll.infiniteScrollComplete');
                }
              } else {
                $scope.vm.moredata = true;
              }
            } else {
              $ionicLoading.hide();
              $scope.data = ret.data.rows;
            }
          } else {
            $scope.vm.moredata = true;
            $ionicPopup.alert({
              title: '提示',
              template: ret.msg
            });
            if (String(ret.msg).includes('登录')) {
              $location.url('/tab/appointment/quicklogin?source_url=/tab/appointment&back=true');
            }
          }
        }
      );
    };
    var vm = $scope.vm = {
      moredata: false,
      messages: [],
      pagination: {
        perPage: 5,
        currentPage: 1
      },
      init: function () {
        getMessageData(1);
      },
      show: function (message) {
        if (message.static) {
          message.static = false;
        } else {
          message.static = true;
        }
      },
      loadMore: function () {
        vm.pagination.currentPage += 1;
        var page = vm.pagination.currentPage;
        getMessageData(page);
      }
    };
    vm.init();

    $scope.openLink = function (url) {
      Public.openLinkInApp("https://" + Variable.url + url);
    };
  })
  //我的预约
  .controller('UserAppointmentCtrl', function ($scope, $http, $location, $ionicPopup, $ionicLoading, $stateParams, Storage, Variable, Public) {
    $ionicLoading.show({
      template: '<ion-spinner icon="ios" class="popup-loading"></ion-spinner>',
      noBackdrop: true,
      duration: 5000
    });
    //获取预约列表数据
    var url = "https://" + Variable.url + "/client/memMng/memAppointment/getAppointmentsByIonic?fu_app_id=" + Storage.get('fu_app_id') + "&callback=JSON_CALLBACK";
    $http.jsonp(url, {
      cache: false
    }).success(
      function (ret) {
        $ionicLoading.hide();
        if (ret.code === 0) {
          $scope.data = ret.data;
        } else {
          $ionicPopup.alert({
            title: '提示',
            template: ret.msg
          });
          if (String(ret.msg).includes('登录')) {
            $location.url('/tab/appointment/quicklogin?source_url=/tab/appointment&back=true');
          }
        }
      }
    );

    $scope.openLink = function (url) {
      Public.openLinkInApp(url);
    };
  })
  .controller('PublishCtrl', function ($rootScope, $scope, $http, $location, $ionicPopup, $ionicLoading, $ionicModal, $cordovaImagePicker, $stateParams, $cordovaFileTransfer, $interval, Search, Storage, ShowTopTip, Variable, Public) {
    if (!Storage.get('city_id')) {
      Storage.set('city_id', 3399);
      Storage.set('city_name', '深圳');
      Storage.set('ct_index', 'sz');
    }

    $scope.city_name = Storage.get('city_name');
    $scope.ppt_name = Storage.get('publish_ppt_name');

    $scope.parent = {};

    if ($scope.ppt_name) {
      var data = {
        city_id: Storage.get('city_id'),
        ppt_name: $scope.ppt_name,
        type: 'ionic'
      };
      var url = "https://" + Variable.url + "/client/memMng/memApartmentMng/checkPptExisted?" + $.param(data) + "&callback=JSON_CALLBACK";
      $http.jsonp(url).success(
        function (ret) {
          if (ret[0]) {
            $scope.showRegion = false;
          } else {
            var data = {
              city_id: Storage.get('city_id'),
              type: 'ionic'
            };
            var url = "https://" + Variable.url + "/client/memMng/memApartmentMng/getRegions?" + $.param(data) + "&callback=JSON_CALLBACK";
            $http.jsonp(url).success(
              function (ret) {
                $scope.region_data = ret;
                $scope.parent.region_id = ret[0].region_id;
                $scope.region_name = ret[0].region_name;
                if (Storage.get('publish_region_id')) {
                  angular.forEach(ret, function (value, index) {
                    if (Storage.get('publish_region_id') == value.region_id) {
                      $scope.parent.region_id = ret[index].region_id;
                      $scope.region_name = ret[index].region_name;
                    }
                  });
                }
                $scope.showRegion = true;
                Storage.remove('publish_region_id');
              }
            );
          }
        }
      );
    } else {
      $scope.showRegion = false;
    }

    $scope.selectCity = function () {
      $location.path('/tab/publish/city');
    };

    $scope.selectPpt = function () {
      $location.path('/tab/publish/property');
    };

    $scope.selectRegion = function () {
      angular.forEach($scope.region_data, function (value, index) {
        if ($scope.parent.region_id == value.region_id) {
          $scope.region_name = $scope.region_data[index].region_name;
        }
      });
    };

    $scope.formData = {};
    $scope.formData.fu_mobile = Storage.get('own_number');
    $scope.processForm = function () {
      if ($scope.showLogin) {
        if (!$scope.city_name) {
          ShowTopTip("请选择城市");

          return false;
        }

        if (!$scope.ppt_name) {
          ShowTopTip("请选择楼盘");

          return false;
        }

        if ($scope.showRegion && !$scope.parent.region_id) {
          ShowTopTip("请选择区域");

          return false;
        }

        if ($scope.formData.fu_mobile < 10000000000 || $scope.formData.fu_mobile > 99999999999 || !$scope.formData.fu_mobile) {
          ShowTopTip("请输入正确的手机号");

          return false;
        }

        if (!$scope.formData.vcode || $scope.formData.vcode.length != 6) {
          ShowTopTip("请输入正确的短信验证码");

          return false;
        }

        $ionicLoading.show({
          template: '<ion-spinner icon="ios" class="popup-loading"></ion-spinner>',
          noBackdrop: true,
          duration: 5000
        });
        var data = {
          source: 'zufun',
          fu_app_id: Storage.get('fu_app_id'),
          fu_mobile: $scope.formData.fu_mobile,
          vcode: $scope.formData.vcode
        };
        var url = "https://" + Variable.url + "/client/memMng/memLogin/registerMemberByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
        $http.jsonp(url).success(
          function (ret) {
            $ionicLoading.hide();
            if (ret.code === 0) {

              Storage.set('fu_mobile', ret.data.fu_mobile);
              Storage.set('fu_name', ret.data.fu_name);
              Storage.set('msgnum', ret.data.msgnum);
              //设置消息数量
              $rootScope.msgnum = Number(ret.data.msgnum) || 0;

              Storage.set('publish_ppt_name', $scope.ppt_name);
              if ($scope.showRegion) {
                Storage.set('publish_region_id', $scope.parent.region_id);
              }
              $location.path('/tab/publish/new');
            } else if (ret.code === 'ERR_PICCODE') {
              $scope.showRequiredError = true;
              $scope.get_pic_code();
              setTimeout(function () {
                $ionicPopup.show({
                  template: '<div class="form-group"><div class="form-group-inupt"><input ng-model="smsData.pic_code" name="pic_code" type="tel" autofocus style="padding-right:65px; padding-left:5px;"></div><div id="pic_code" class="pic-code" ng-click="get_pic_code();" ><img src="{{pic_src}}" width="100" height="35" style="border:0;"></div></div>',
                  title: '请输入图形验证码',
                  scope: $scope,
                  buttons: [{
                    text: '取消'
                  }, {
                    text: '<b>确定</b>',
                    type: 'button-balanced',
                    onTap: function (e) {
                      if ($scope.smsData.pic_code) {
                        var data = {
                          source: 'zufun',
                          fu_app_id: Storage.get('fu_app_id'),
                          fu_mobile: $scope.formData.fu_mobile,
                          vcode: $scope.formData.vcode,
                          pic_code: $scope.smsData.pic_code
                        };
                        var url = "https://" + Variable.url + "/client/memMng/memLogin/registerMemberByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
                        $http.jsonp(url).success(
                          function (ret) {
                            if (ret.code === 0) {
                              Storage.set('fu_mobile', ret.data.fu_mobile);
                              Storage.set('fu_name', ret.data.fu_name);
                              Storage.set('msgnum', ret.data.msgnum);
                              //设置消息数量
                              $rootScope.msgnum = Number(ret.data.msgnum) || 0;

                              Storage.set('publish_ppt_name', $scope.ppt_name);
                              if ($scope.showRegion) {
                                Storage.set('publish_region_id', $scope.parent.region_id);
                              }
                              $location.path('/tab/publish/new');
                            } else {
                              $ionicPopup.alert({
                                title: '提示',
                                template: ret.msg
                              });
                            }
                          }
                        );
                      } else {
                        alert("请输入图形验证码");
                        return false;
                      }
                    }
                  },]
                });
              }, 300);
            } else {
              $ionicPopup.alert({
                title: '提示',
                template: ret.msg
              });
            }
          }
        );
      } else {
        if (!$scope.city_name) {
          ShowTopTip("请选择城市");

          return false;
        }

        if (!$scope.ppt_name) {
          ShowTopTip("请选择楼盘");

          return false;
        }

        if ($scope.showRegion && !$scope.parent.region_id) {
          ShowTopTip("请选择区域");

          return false;
        }

        Storage.set('publish_ppt_name', $scope.ppt_name);
        if ($scope.showRegion) {
          Storage.set('publish_region_id', $scope.parent.region_id);
        }
        $location.path('/tab/publish/new');
      }

    };

    /**
     * 判断控制；发送验证码的按钮文字颜色；
     */
    $scope.$watch('formData.fu_mobile', function (newValue, oldValue) {
      if (newValue) {
        if (newValue.length == 11) {
          $scope.paraclass = '';
        } else {
          $scope.paraclass = 'c-gray';
        }
      }
    });

    //发送验证码
    $scope.paracont = '获取验证码';
    $scope.paraclass = 'c-gray';
    $scope.paraevent = true;
    var countDown = function () {
      var second = 30,
        timePromise;

      timePromise = $interval(function () {
        if (second <= 0) {
          $interval.cancel(timePromise);
          timePromise = '';
          second = 30;
          $scope.paracont = '获取验证码';
          $scope.paraclass = '';
          $scope.paraevent = true;
        } else {
          $scope.paracont = '重新发送(' + second + ')';
          $scope.paraclass = 'c-gray';
          second--;
        }
      }, 1000, 100);
    };
    $scope.smsData = {};
    $scope.sendVcode = function () {
      if ($scope.formData.fu_mobile < 10000000000 || $scope.formData.fu_mobile > 99999999999 || !$scope.formData.fu_mobile) {
        ShowTopTip("请输入正确的手机号");

        return false;
      }

      if ($scope.paraclass == 'c-gray') {
        return false;
      }

      $scope.showRequiredError = true;
      $scope.get_pic_code();
      setTimeout(function () {
        $ionicPopup.show({
          template: '<div class="form-group"><div class="form-group-inupt"><input ng-model="smsData.pic_code" name="pic_code" type="tel" autofocus style="padding-right:65px; padding-left:5px;"></div><div id="pic_code" class="pic-code" ng-click="get_pic_code();" ><img src="{{pic_src}}" width="100" height="35" style="border:0;"></div></div>',
          title: '请输入图形验证码',
          scope: $scope,
          buttons: [{
            text: '取消'
          }, {
            text: '<b>确定</b>',
            type: 'button-balanced',
            onTap: function (e) {
              if ($scope.smsData.pic_code) {
                var data = {
                  fu_mobile: $scope.formData.fu_mobile,
                  pic_code: $scope.smsData.pic_code,
                  type: 'appoint'
                };
                var url = "https://" + Variable.url + "/client/memMng/memLogin/sendSmsForRegByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
                $http.jsonp(url).success(
                  function (ret) {
                    if (ret.code === 0) {
                      countDown(); //倒计时
                    } else {
                      ShowTopTip(ret.msg);
                      $scope.get_pic_code();
                    }
                    $scope.smsData.pic_code = '';
                  }
                );
              } else {
                alert("请输入图形验证码");
                return false;
              }
            }
          },]
        });
      }, 300);
    };

    //图片验证码
    var pic_url = "https://" + Variable.url + "/client/memMng/memLogin/getPiccodeByIonic?callback=JSON_CALLBACK";
    $scope.get_pic_code = function () {
      $http.jsonp(pic_url).success(
        function (ret) {
          if (ret.code === 0) {
            $scope.pic_src = ret.data;
          } else {
            ShowTopTip(ret.msg);
          }
        }
      ).error(function (err) {
        console.log('err:' + err);
      });
    };

    $scope.openLink = function (url) {
      Public.openLinkInApp(url);
    };

    if (Storage.get('fu_mobile')) {
      $ionicLoading.show({
        template: '<ion-spinner icon="ios" class="popup-loading"></ion-spinner>',
        noBackdrop: true,
        duration: 5000
      });
      var data = {
        fu_app_id: Storage.get('fu_app_id')
      };
      var url = "https://" + Variable.url + "/client/memMng/memApartmentMng/getApartsByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
      $http.jsonp(url).success(
        function (ret) {
          if (ret.code === 0) {
            $scope.data = ret.data;
            $ionicLoading.hide();
          } else {
            //  $ionicPopup.alert({
            //      title: '提示',
            //      template: ret.msg
            //  });
          }
        }
      );

      $scope.showLogin = false;
    } else {
      $scope.showLogin = true;
    }
  })
  .controller('PublishNewCtrl', function ($rootScope, $scope, $http, $location, $ionicPopup, $ionicLoading, $ionicModal, $cordovaImagePicker, $stateParams, $cordovaFileTransfer, $interval, Search, Storage, ShowTopTip, Variable, Public) {
    $scope.ppt_name = Storage.get('publish_ppt_name');
    $scope.region_id = Storage.get('publish_region_id');

    //添加图片、图片加载效果
    var picChange = function (data, type) {
      if (type == 'spinner') {
        return {
          spinner: true
        };
      } else {
        return {
          src: "https://" + Variable.url + "/" + data.src
        };
      }

    };
    $scope.search = Search;
    //处理表单数据
    $scope.formData = {};
    $scope.formData.att_rent_type = 1;
    $scope.formData.att_deposit = 1;
    $scope.formData.att_min_period = 5;
    $scope.type = 2;
    $scope.items = [];
    var updateSelected = function (action, id) {
      if (action == 'add' && $scope.items.indexOf(id) == -1) {
        $scope.items.push(id);
      }
      if (action == 'remove' && $scope.items.indexOf(id) != -1) {
        var idx = $scope.items.indexOf(id);
        $scope.items.splice(idx, 1);
      }
    }
    $scope.updateSelection = function (id, $event) {
      var checkbox = $event.target;
      var action = (checkbox.checked ? 'add' : 'remove');
      updateSelected(action, id);
    }
    $scope.isSelected = function (id) {
      return $scope.items.indexOf(id) >= 0;
    }
    $scope.checkAll = function () {
      $scope.items = [36, 1, 2, 6, 8, 10, 11, 13, 14, 23, 25];
    };
    $scope.cancelAll = function () {
      $scope.items = [];
    };

    //图片管理
    $ionicModal.fromTemplateUrl('templates/user/publish_pic.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function (modal) {
      $scope.modal = modal;
    });
    $scope.openModal = function () {
      $scope.modal.show();
    };
    $scope.closeModal = function () {
      $scope.modal.hide();
    };

    //上传图片test;
    // var ft = new FileTransfer();
    $scope.pics = [];
    var options = {
      maximumImagesCount: 10,
      width: 800,
      height: 800,
      quality: 80
    };

    var getPictures = function () {
      $cordovaImagePicker.getPictures(options)
        .then(function (results) {
          for (var i = 0; i < results.length; i++) {
            var options = new FileUploadOptions();
            options.fileKey = 'file';
            options.fileName = results[i].substr(results[i].lastIndexOf('/') + 1);
            options.httpMethod = 'post';
            options.mimeType = 'image/jpeg';

            $scope.pics.push(picChange('', 'spinner'));
            $cordovaFileTransfer.upload("https://" + Variable.url + "/client/memMng/memApartmentMng/ionicUploadTempPhoto/?fu_app_id=" + Storage.get('fu_app_id'), results[i], options)
              .then(function (data) {
                var ret = JSON.parse(data.response);
                var flag = true;
                angular.forEach($scope.pics, function (value, index) {
                  if (!$scope.modal.isShown()) {
                    $scope.modal.show();
                  }
                  if (value.spinner && flag) {
                    flag = false;
                    ret.data.src = "https://" + Variable.url + "/" + ret.data.src;
                    ret.data.tmp_name = ret.data.src;
                    $scope.pics[index] = ret.data;
                    if (!$scope.feng && index == 0) {
                      $scope.feng = ret.data.key;
                      $scope.fengPic = ret.data.src;
                    }
                    return;
                  }
                });
              }, function (err) {
                // Error
              }, function (progress) {
                // constant progress updates
              });
          }
        }, function (error) {
          console.log(error);
        });
    }

    $scope.getPictures = function () {
      console.log("---------getPictures cordova");
      if (ionic.Platform.isAndroid()) {
        console.log("---------getPictures 1");
        var permissions = cordova.plugins.permissions;
        permissions.hasPermission(permissions.WRITE_EXTERNAL_STORAGE, function (status) {
          if (status.hasPermission) {
            getPictures();
          } else {
            permissions.requestPermission(permissions.WRITE_EXTERNAL_STORAGE, function (status) {
              if (status.hasPermission) {
                getPictures();
              } else {
                $ionicPopup.alert({
                  title: '提示',
                  template: "加载相册失败，请为租房网开启存储权限"
                });
              }
            }, function () {
              $ionicPopup.alert({
                title: '提示',
                template: "加载相册失败，请为租房网开启存储权限"
              });
            });
          }
        });
      } else {
        console.log("---------getPictures 2");
        getPictures();
      }
    };
    //设为封面
    $scope.feng = '';
    $scope.fengPic = '';
    $scope.setPoster = function () {
      if ($scope.isClicked !== '') {
        angular.forEach($scope.pics, function (value, index) {
          if ($scope.isClicked == value.key) {
            $scope.fengPic = $scope.pics[index].src;
          }
        });
        $scope.feng = $scope.isClicked;
        $scope.isClicked = '';
      } else {
        $ionicPopup.alert({
          title: '提示',
          template: "请选中图片"
        });
      }
    };

    //删除图片
    $scope.deletePic = function () {
      if ($scope.isClicked !== '') {
        angular.forEach($scope.pics, function (value, index) {
          if ($scope.isClicked == value.key) {
            $scope.pics.splice(index, 1);
          }
          if (!$scope.pics.length) {
            $scope.feng = '';
            $scope.fengPic = '';
          }
          if ($scope.feng == value.key) {
            $scope.feng = $scope.pics[0].key;
            $scope.fengPic = $scope.pics[0].src;
          }
        });
        $scope.isClicked = '';
      } else {
        $ionicPopup.alert({
          title: '提示',
          template: "请选中图片"
        });
      }
    };

    //图片点击
    $scope.isClicked = '';
    $scope.picClick = function (key) {
      $scope.isClicked = key;
    };

    $scope.changeType = function (type) {
      $scope.formData.att_rent_type = type;
    };

    //发布房源
    $scope.addType = function (type) {
      $scope.type = type;
    };
    $scope.formHander = function () {
      if (!(/^-?[1-9]\d*$/.test($scope.formData.att_rooms))) {
        $ionicPopup.alert({
          title: '提示',
          template: "房间数必须是整数"
        });

        return;
      }
      if (Number($scope.formData.att_rooms) < 1) {
        $ionicPopup.alert({
          title: '提示',
          template: "房间数不能小于1"
        });

        return;
      }
      if (Number($scope.formData.att_rooms) > 9) {
        $ionicPopup.alert({
          title: '提示',
          template: "房间数不能大于9"
        });

        return;
      }
      $scope.formData.att_title = ($scope.formData.att_rent_type == 1 ? '整租' : '合租') + Public.numToChinese(Number($scope.formData.att_rooms)) + '居';
      if ($scope.formData.att_rent_type = 1) {
        if ($scope.items.indexOf(25) != -1) {
          var idx = $scope.items.indexOf(25);
          $scope.items.splice(idx, 1);
        }
        delete $scope.formData.att_total_space;
      } else {
        delete $scope.formData.att_hall_number;
        delete $scope.formData.att_washrooms;
      }
      var data = {
        apart: $scope.formData,
        property: {
          tp_ppt_name: $scope.ppt_name
        },
        items: $scope.items,
        savetype: $scope.type,
        city_id: Storage.get('city_id')
      };
      if ($scope.region_id) {
        data.property.tp_region_id = $scope.region_id;
      }
      if (2 == $scope.type) {
        if ($scope.pics.length <= 0) {
          $ionicPopup.alert({
            title: '提示',
            template: "请上传图片"
          });

          return;
        } else {
          angular.forEach($scope.pics, function (value, index) {
            if ($scope.feng == index) {
              $scope.pics[index].fs_status = 0;
            }
            delete $scope.pics[index]['$$hashKey'];
          });
          data.files = $scope.pics;
        }
      }
      $ionicLoading.show({
        template: '<ion-spinner icon="ios" class="popup-loading"></ion-spinner>',
        noBackdrop: true,
        duration: 5000
      });
      var url = "https://" + Variable.url + "/client/memMng/memApartmentMng/saveApartByIonic?obj=" + JSON.stringify(data) + "&callback=JSON_CALLBACK";
      $http.jsonp(url).success(
        function (ret) {
          $ionicLoading.hide();
          if (ret.code === 0) {
            //  Public.openLinkInApp('https://' + Variable.url + 'user/apt/info/' + ret.data);
            Storage.remove('publish_ppt_name');
            Storage.remove('publish_region_id');
            $location.path('/tab/publish');
          } else {
            $ionicPopup.alert({
              title: '提示',
              template: ret.msg
            });
          }
        }
      ).error(function (err) {
        console.log("err" + err);
      });
    };
  })
  //发布房源城市选择
  .controller('PublishCityCtrl', function ($rootScope, $scope, $http, $location, $cordovaGeolocation, Storage, Search, Variable) {
    if (!Storage.get('city_id')) {
      Storage.set('city_id', 3399);
      Storage.set('city_name', '深圳');
      Storage.set('ct_index', 'sz');
    }

    //设置城市id
    $scope.set_city_id = function (id, name, ct_index) {
      Storage.clearCity(); //清除缓存

      // 设置城市id、城市名字;
      Storage.set('city_id', id);
      Storage.set('city_name', name);
      Storage.set('ct_index', ct_index);

      $location.path('/tab/publish');
    };

    if (!$rootScope.cities) {
      var url = "https://" + Variable.url + "/getCityInfo?callback=JSON_CALLBACK";
      $http.jsonp(url).success(
        function (ret) {
          $rootScope.cities = ret;
        }
      );
    }
  })
  //发布房源楼盘选择
  .controller('PublishPptCtrl', function ($rootScope, $scope, $http, $location, $cordovaGeolocation, Storage, Search, Variable) {
    if (!Storage.get('city_id')) {
      $location.path('/tab/publish/city');
    }

    $scope.drop_tips = [];

    $scope.select_ppt = function (ppt_name) {
      if (ppt_name) {
        Storage.set('publish_ppt_name', ppt_name);
      }
      $location.path('/tab/publish');
    };
    $scope.sendKeyword = function (keyword) {
      $scope.ppt_name = keyword;
      var data = {
        ppt_name: keyword,
        city_id: Storage.get('city_id')
      };
      var url = "https://" + Variable.url + "/client/search/search/getPptnameByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";

      $http.jsonp(url).success(
        function (ret) {
          if (ret.code === 0) {
            $scope.drop_tips = ret.data;
          } else {
            $ionicPopup.alert({
              title: '提示',
              template: ret.msg
            });
          }
        }
      );
    };
  })
//	.directive("scroll", function ($window) {
//        return {
//            restrict: "A",
//            link: function(scope, element) {
//                element.on('scroll', function(event) {
//                    if (event.target.scrollTop > 0) {
//                        StatusBar.backgroundColorByHexString("#c1c1c1");
//                    } else {
//                        StatusBar.overlaysWebView(true);
//                    }
//                });
//            }
//        };
//    });