// alert('hello world');
angular.module('starter.filter', [])

//转换成html
.filter('trustHtml', function($sce) {
    return function (input) {
         return $sce.trustAsHtml(input);
    };
})

//二手房单价转换
.filter('convertEsfUnitSell', function() {
    return function (unitSell){
        if(unitSell < 10000){
            return unitSell+'元/m²';
        }else{
            return (unitSell/10000).toFixed(1)+'万/m²';
        }
     };
})
.directive('compile', function($compile, $parse) {
    return {
      restrict: 'A',
      link: function(scope, element, attr) {
        scope.$watch(attr.compile, function() {
            element.html($parse(attr.compile)(scope));
            $compile(element.contents())(scope);
        }, true);
      }
    };
})
.directive('hideTabs', function($rootScope) {
    return {
        restrict: 'A',
        link: function(scope, element, attributes) {
            scope.$on('$ionicView.beforeEnter', function() {
                scope.$watch(attributes.hideTabs, function(value){
                    $rootScope.hideTabs = value;
                });
            });

            scope.$on('$ionicView.beforeLeave', function() {
                $rootScope.hideTabs = false;
            });
        }
    };
})

.directive('showRequiredError', function($rootScope) {
    return {
        restrict: 'A',
        link: function(scope, element, attributes) {
            element.on('click',function(){
                scope.showRequiredError = true;
            });
        }
    };
})

.directive('menu', function($rootScope,$ionicModal,$location,$stateParams,$ionicPopup,Public,Storage,Variable) {
    return {
        restrict:'E',
        replace:true,
        transclude:true,
        template:'<div class="{{menu_off}} {{display}} none">'+
                    '<a class="mem-masker" ng-click="menu();"></a>'+
                    '<nav id="menu" class="menu-page">'+
                        '<div class="menu-title">租房网<a ng-click="menu();" class="menu-close">×</a></div>'+
                        '<ul>'+
                            '<li>'+
                                '<a ng-click="openLink(\'list/1\')">'+
                                    '<span class="icon-nzf"></span>租房'+
                                '</a>'+
                            '</li>'+
                            '<li>'+
                                '<a ng-click="openLink(\'officelist/1\')">'+
                                    '<span class="icon-nesf"></span>写字楼'+
                                '</a>'+
                            '</li>'+
                            '<li>'+
                                '<a ng-click="openLink(\'user/apt/new\')">'+
                                    '<span class="icon-napart"></span>发布房源'+
                                '</a>'+
                            '</li>'+
                            '<li>'+
                                '<a ng-click="openLink(\'https://'+Variable.url+'/platform\')">'+
                                    '<span class="icon-nplatform"></span>物业平台'+
                                '</a>'+
                            '</li>'+
                            '<li>'+
                                '<a ng-click="openLink(\'https://'+Variable.url+'/about\')">'+
                                    '<span class="icon-about"></span>关于我们'+
                                '</a>'+
                            '</li>'+
                        '</ul>'+
                   '</nav>'+
                '</div>',
        link: function(scope, element, attributes) {
            scope.menu_background = ''; //menu-background
            scope.menu_off = 'menu-off';
           
            scope.menu = function(){
               if(scope.menu_off === 'menu-off'){
                   scope.menu_off = '';
                   scope.display = 'block';
               }else{
                   scope.menu_off = 'menu-off';
               }


               if(scope.menu_background === ''){
                   scope.menu_background = 'menu-background';
               }else{
                   scope.menu_background = '';
               }
           };
        }
    };
});