angular.module('starter.services', [])
  .factory('jpushService', ['$http', '$window', '$document', function ($http, $window, $document) {
    var jpushServiceFactory = {};

    //var jpushapi=$window.plugins.jPushPlugin;

    //启动极光推送
    var _init = function (config) {
      console.log("----------启动极光推送")
      $window.plugins.jPushPlugin.init();
      //设置tag和Alias触发事件处理
      window.JPush.setDebugMode(false);
      document.addEventListener('jpush.receiveRegistrationId', function (event) {
        console.log(event.registrationId)
      }, false)
      window.JPush.getRegistrationID(function (rId) {
        console.log("JPushPlugin:registrationID is " + rId)
      })

      document.addEventListener('jpush.setTagsWithAlias', config.stac, false);

      //点击推送通知
      document.addEventListener("jpush.openNotification", config.onOpenNotification, false);

      //前台收到推送： 
      document.addEventListener("jpush.receiveNotification", config.onReceiveNotification, false);

      //后台收到推送： 
      document.addEventListener("jpush.backgroundNotification", config.onBackgroundNotification, false);

      //打开推送消息事件处理
      $window.plugins.jPushPlugin.openNotificationInAndroidCallback = config.oniac;


      //  $window.plugins.jPushPlugin.setDebugMode(false);
    };
    //获取状态
    var _isPushStopped = function (fun) {
      $window.plugins.jPushPlugin.isPushStopped(fun);
    };
    //停止极光推送
    var _stopPush = function () {
      $window.plugins.jPushPlugin.stopPush();
    };

    //重启极光推送
    var _resumePush = function () {
      $window.plugins.jPushPlugin.resumePush();
    };

    //设置标签和别名
    var _setTagsWithAlias = function (tags, alias) {
      $window.plugins.jPushPlugin.setTagsWithAlias(tags, alias);
    };

    //设置标签
    var _setTags = function (tags) {
      $window.plugins.jPushPlugin.setTags(tags);
    };

    //设置别名
    var _setAlias = function (alias) {
      //  $window.plugins.jPushPlugin.setAlias(alias);
      window.JPush.setAlias({ sequence: 1, alias: alias },
        function (result) {
          console.log(JSON.stringify(result));
        }, function (error) {
          console.log(error.code);
        })
    };

    //设置badges:
    var _setApplicationIconBadgeNumber = function (badge) {
      $window.plugins.jPushPlugin.setApplicationIconBadgeNumber(badge);
    };

    //服务器设置badge;
    // window.plugins.jPushPlugin.prototype.setBadge(value)
    // window.plugins.jPushPlugin.prototype.reSetBadge()
    var _setBadge = function (badge) {
      $window.plugins.jPushPlugin.setBadge(badge);
    };

    var _reSetBadge = function (badge) {
      $window.plugins.jPushPlugin.reSetBadge();
    };

    jpushServiceFactory.init = _init;
    jpushServiceFactory.isPushStopped = _isPushStopped;
    jpushServiceFactory.stopPush = _stopPush;
    jpushServiceFactory.resumePush = _resumePush;

    jpushServiceFactory.setTagsWithAlias = _setTagsWithAlias;
    jpushServiceFactory.setTags = _setTags;
    jpushServiceFactory.setAlias = _setAlias;

    jpushServiceFactory.setBadge = _setBadge;
    jpushServiceFactory.reSetBadge = _reSetBadge;
    jpushServiceFactory.setApplicationIconBadgeNumber = _setApplicationIconBadgeNumber;

    return jpushServiceFactory;
  }])
  .factory('Storage', function () {
    return {
      set: function (key, data) {
        return window.localStorage.setItem(key, window.JSON.stringify(data));
      },
      get: function (key) {
        if (window.localStorage.getItem(key) != 'undefined') {
          return window.JSON.parse(window.localStorage.getItem(key));
        }
      },
      remove: function (key) {
        return window.localStorage.removeItem(key);
      },
      clear: function () {
        return window.localStorage.clear();
      },
      clearCity: function () {
        window.localStorage.removeItem('city_id');
        window.localStorage.removeItem('city_name');
        window.localStorage.removeItem('hot_search');
        window.localStorage.removeItem('cityDataCache');
        window.localStorage.removeItem('today');
      },
      clearUser: function () {
        window.localStorage.removeItem('fu_mobile');
        window.localStorage.removeItem('fu_name');
        window.localStorage.removeItem('msgnum');
        window.localStorage.removeItem('feedbacknum');
        window.localStorage.removeItem('isPcUser');
      }
    };
  })
  //全局变量
  .factory('Variable', function () {
    return {
      url: 'm.zufun.cn'
    };
  })
  // 检查用户是否登录；
  .factory('CheckUserLogin', function ($http, $rootScope, Storage, Variable) {
    return function () {
      var checkUrl = "https://" + Variable.url + "/index/checkAppUserLogin?fu_app_id=" + Storage.get('fu_app_id') + "&callback=JSON_CALLBACK";
      $http.jsonp(checkUrl).success(
        function (ret) {
          // $ionicLoading.hide();
          if (ret.code === 0) {
            Storage.set('fu_mobile', ret.data.fu_mobile);
            Storage.set('msgnum', ret.data.msgnum);
            Storage.set('feedbacknum', ret.data.feedbacknum);
            Storage.set('fu_name', ret.data.fu_name);
            Storage.set('isPcUser', ret.data.isPcUser);
            Storage.set('kf_mobile', ret.data.kf_mobile);
            //设置消息数量
            $rootScope.msgnum = Number(ret.data.msgnum) || 0;
            $rootScope.feedbacknum = Number(ret.data.feedbacknum) || 0;
          } else {
            Storage.clearUser();
          }
        }
      ).error(function (err) {
        console.log('err:' + err);
      });
    };
  })


  //提示信息；
  .factory('ShowTopTip', function (Storage) {
    return function (str) {
      if (!$("#toptip").length > 0) {
        // ios/android，20px
        var topTipClass = '';
        if (Storage.get('StatusBarHeight')) {
          topTipClass = 'topTip';
        } else {
          topTipClass = 'topTipAndroid';
        }

        $("body").append('<div id="toptip" class="' + topTipClass + '"><div class="topTipStr">' + str + '</div></div>');
        setTimeout(function () {
          $("#toptip").addClass('trans');
        }, 2000);
        setTimeout(function () {
          $("#toptip").remove();
        }, 2500);
      }
    };
  })

  //公用的函数、变更
  .factory('Public', function ($http, $ionicPopup, $rootScope, $location, $cordovaInAppBrowser, Storage, Variable, CheckUserLogin) {
    return {
      readPhoneState: function () {
        if (!Storage.get('own_number')) {
          if (Storage.get('protocol')) {
            console.log("zf Public 已同意隐私协议 调用手机权限");
            if (device.platform == "Android") {
              var permissions = cordova.plugins.permissions;
              permissions.hasPermission(permissions.READ_PHONE_STATE, function (status) {
                if (status.hasPermission) {
                  window.plugins.sim.getSimInfo(function (res) {
                    Storage.set('own_number', res.phoneNumber.replace(/\+?86/, ''));
                  });
                } else {
                  permissions.requestPermission(permissions.READ_PHONE_STATE, function (status) {
                    if (status.hasPermission) {
                      window.plugins.sim.getSimInfo(function (res) {
                        Storage.set('own_number', res.phoneNumber.replace(/\+?86/, ''));
                      });
                    }
                  });
                }
              });
            } else if (device.platform == "iOS") {
              window.plugins.sim.getSimInfo(function (res) {
                Storage.set('own_number', res.phoneNumber.replace(/\+?86/, ''));
              });
            } else if (device.platform == "browser") {
              console.log("zf Public-brwser 调用 请求");
            }
          }
        }
      },
      // jpushService 初始化
      initjpushService: function (jpushService) {

        //推送初始化
        var setTagsWithAliasCallback = function (event) {
          switch (event.resultCode) {
            case 6002:
              setTimeout(function () {
                jpushService.setAlias(Storage.get('fu_app_id'));
              }, 60000);
              break;
          }
          // window.alert('result code:'+event.resultCode+' tags:'+event.tags+' alias:'+event.alias);
        };
        var openNotificationInAndroidCallback = function (data) {
          var json = data,
            route = '',
            id = '',
            type = '';
          if (typeof data === 'string') {
            json = JSON.parse(data);
          }
          if (device.platform == "Android") {
            route = json.extras['cn.jpush.android.EXTRA'].route;
            id = json.extras['cn.jpush.android.EXTRA'].id;
            type = json.extras['cn.jpush.android.EXTRA'].type;
          } else {
            route = json.route;
            id = json.id;
            type = json.type;
          }
          if ('promote' == type) {
            Public.openLinkInApp(route);
          } else {
            if (Storage.get('isPcUser')) {
              CheckUserLogin(); //检查消息数量；
              $state.go('tab.pcmessage');
            } else {
              CheckUserLogin(); //检查消息数量；
              $state.go('tab.message');
            }
          }
        };

        //点击推送通知：
        var onOpenNotification = function (event) {
          if ('promote' == event.type) {
            Public.openLinkInApp(event.route);
          } else {
            CheckUserLogin(); //检查消息数量；
            if (Storage.get('isPcUser')) {
              $state.go('tab.pcmessage');
            } else {
              $state.go('tab.message');
            }
            jpushService.setApplicationIconBadgeNumber(0);
            jpushService.setBadge(0);
          }
        };

        // 前台收到推送：
        var onReceiveNotification = function (event) {
          // var alertContent
          // alertContent = event.aps.alert
          // alert("open Notificaiton:" + alertContent)
          //
          // alert("前台获取");
        };


        //后台收到推送：
        var onBackgroundNotification = function (event) {
          // var alertContent
          // alertContent = event.aps.alert
          // alert("open Notificaiton:" + alertContent);
          // alert("后台获取");
          // window.plugins.jPushPlugin.prototype.setBadge(value)
          // window.plugins.jPushPlugin.prototype.reSetBadge()
          window.plugins.jPushPlugin.getApplicationIconBadgeNumber(function (data) {
            jpushService.setApplicationIconBadgeNumber(data + 1);
          });
        };

        var config = {
          stac: setTagsWithAliasCallback,
          oniac: openNotificationInAndroidCallback,
          onOpenNotification: onOpenNotification, //点击推送通知；
          onReceiveNotification: onReceiveNotification, //前台收到消息；
          onBackgroundNotification: onBackgroundNotification //后台收到消息：
        };
        jpushService.init(config);
        jpushService.setApplicationIconBadgeNumber(0);

        var fu_app_id;
        if (Storage.get('fu_app_id')) {
          fu_app_id = Storage.get('fu_app_id');
        } else {
          fu_app_id = '';
        }
        var app_data = {
          uuid: device.uuid,
          cordova: device.cordova,
          version: device.version,
          platform: device.platform,
          fu_app_id: fu_app_id
        };
        var app_url = "https://" + Variable.url + "/index/getAppidByIonic?" + $.param(app_data) + "&callback=JSON_CALLBACK";
        $http.jsonp(app_url).success(
          function (ret) {
            if (ret.code === 0) {
              Storage.set('fu_app_id', ret.data);
              jpushService.setAlias(ret.data);
            }
          }
        ).error(function (err) {
          console.log('err:' + err);
        });

      },
      openLinkInApp: function (url) {
        
        // var options = { dimBackground: true };
        // SpinnerPlugin.activityStop();
        var options = {
          location: 'no',
          clearcache: 'no',
          clearsessioncache: 'no',
          toolbar: 'no',
          transitionstyle: 'crossdissolve'
        },
          tag_url = '';
        if (url.indexOf('http') <= -1) {
          if (url.indexOf('user') > -1 && url.indexOf('user/esf/apt/new') <= -1) {
            tag_url = 'https://' + Variable.url + '/' + url;
          } else {
            tag_url = 'https://' + Variable.url + '/' + Storage.get('ct_index') + '/' + url;
          }
        } else {
          tag_url = url;
        }
        if (tag_url.indexOf('?') > -1) {
          tag_url = tag_url + '&fu_app_id=' + Storage.get('fu_app_id');
        } else {
          tag_url = tag_url + '?fu_app_id=' + Storage.get('fu_app_id');
        }
        $cordovaInAppBrowser.open(tag_url, '_blank', options);
        
        // // var options = { dimBackground: true };
        // // SpinnerPlugin.activityStop();
        // var options = {
        //   location: 'no',
        //   clearcache: 'no',
        //   clearsessioncache: 'no',
        //   toolbar: 'no',
        //   transitionstyle: 'crossdissolve'
        // },
        //   tag_url = '';
        // if (url.indexOf('http') <= -1) {
        //   if (url.indexOf('user') > -1 && url.indexOf('user/apt/new') <= -1) {
        //     tag_url = 'https://' + Variable.url + '/' + url;
        //   } else {
        //     // Storage.get('ct_index')
        //     tag_url = 'https://' + Variable.url + '/' + Storage.get('ct_index') + '/' + url;
        //   }
        // } else {
        //   tag_url = url;
        // }


        // if (tag_url.indexOf('?') > -1) {
        //   tag_url = tag_url + '&fu_app_id=' + Storage.get('fu_app_id');
        // } else {
        //   tag_url = tag_url + '?fu_app_id=' + Storage.get('fu_app_id');
        // }
        // //			if(tag_url.indexOf('apptInfo')>-1){
        // //				$cordovaInAppBrowser.open(tag_url,'_system');
        // //			}else{
        // //				$cordovaInAppBrowser.open(tag_url,'_blank', options);
        // //			}
        // $cordovaInAppBrowser.open(tag_url, '_blank', options);
      },
      openLinkInSystem: function (url) {
        var tag_url = "";
        if (url.indexOf('http') <= -1) {
          if (url.indexOf('user') > -1 && url.indexOf('user/apt/new') <= -1) {
            tag_url = 'https://' + Variable.url + '/' + url;
          } else {
            // Storage.get('ct_index')
            tag_url = 'https://' + Variable.url + '/' + Storage.get('ct_index') + '/' + url;
          }
        } else {
          tag_url = url;
        }
        if (tag_url.indexOf('?') > -1) {
          tag_url = tag_url + '&fu_app_id=' + Storage.get('fu_app_id');
        } else {
          tag_url = tag_url + '?fu_app_id=' + Storage.get('fu_app_id');
        }
        $cordovaInAppBrowser.open(tag_url, '_system');
      },
      openLink: function (url) {

        var tag_url = '';
        if (url.indexOf('http') <= -1) {
          if (url.indexOf('user') > -1) {
            tag_url = 'https://' + Variable.url + '/' + url + '?fu_app_id=' + Storage.get('fu_app_id');
          } else {
            // Storage.get('ct_index')
            tag_url = 'https://' + Variable.url + '/' + Storage.get('ct_index') + '/' + url + '?fu_app_id=' + Storage.get('fu_app_id');
          }
        } else {
          tag_url = url + '?fu_app_id' + Storage.get('fu_app_id');
        }

        window.cordova.ThemeableBrowser.open(tag_url, '_blank', {
          statusbar: {
            color: '#ffffff'
          },
          toolbar: {
            height: 44,
            wwwImage: 'img/www_toolbar.png',
            wwwImagePressed: 'img/www_toolbar.png',
            color: '#ffffff',
            wwwImageDensity: 3,//数字越大图片越小
          },
          title: {
            color: '#333333',
            showPageTitle: true
          },
          backButton: {
            wwwImage: 'img/www_back.png',
            wwwImagePressed: 'img/www_back.png',
            wwwImageDensity: 3,//数字越大图片越小
            align: 'left',
            event: 'backPressed'
          },
          customButtons: [
            {
              // wwwImage: 'img/www_share.png',
              // wwwImagePressed: 'img/www_share.png',
              // wwwImageDensity:3,//数字越大图片越小
              // align: 'right',
              // event: 'sharePressed'
            }
          ],
          menu: {
            wwwImage: 'img/www_menu.png',
            wwwImagePressed: 'img/www_menu.png',
            wwwImageDensity: 3,//数字越大图片越小
            title: 'Test',
            cancel: 'Cancel',
            align: 'right',
            items: [
              {
                event: 'helloPressed',
                label: 'Hello World!'
              },
              {
                event: 'testPressed',
                label: 'Test!'
              }
            ]
          },
          backButtonCanClose: true,
          fullscreen: false
        }).addEventListener('backPressed', function (e) {
          alert('back pressed');
        }).addEventListener('helloPressed', function (e) {
          alert('hello pressed');
        }).addEventListener('sharePressed', function (e) {
          cordova.exec(function (result) {
            alert('分享成功');
          }, function (error) {
            alert('分享失败');
          }, "ShareSDK", "share", ['测试分享标题', '你们好啊这里是测试分享', null, e.url]);
        }).addEventListener(cordova.ThemeableBrowser.EVT_ERR, function (e) {
          console.error(e.message);
        }).addEventListener(cordova.ThemeableBrowser.EVT_WRN, function (e) {
          console.log(e.message);
        }).addEventListener("loadstart", function (e) {
          // alert('eeeeeeeeeee');
          console.log(e);
          console.log(JSON.stringify(e));
          window.cordova.ThemeableBrowser.close();
        });

        // window.cordova.ThemeableBrowser.open(url, '_system', {
        //   statusbar: {
        //     color: '#f1f1f1'
        //   },
        //   toolbar: {
        //     height: 45,
        //     color: '#00ab99'
        //   },
        //   title: {
        //     color: '#ffffff',
        //     showPageTitle: true
        //   },
        //   backButton: {
        //     wwwImage: 'img/back.png',
        //     wwwImagePressed: 'img/back.png',
        //     align: 'left',
        //     event: 'backPressed'
        //   },
        //   // customButtons: [
        //   //     {
        //   //         image: 'share',
        //   //         imagePressed: 'share_pressed',
        //   //         align: 'right',
        //   //         event: 'sharePressed'
        //   //     }
        //   // ],
        //   backButtonCanClose: true,
        //   fullscreen: true
        // }).addEventListener('backPressed', function (e) {
        //   // history.go(-1);
        //   // window.history.back();
        //   // return false;
        // })/*.addEventListener('sharePressed', function(e) {
        //           alert(e.url);
        //       })*/.addEventListener(cordova.ThemeableBrowser.EVT_ERR, function (e) {
        //   console.error(e.message);
        // }).addEventListener(cordova.ThemeableBrowser.EVT_WRN, function (e) {
        //   console.log(e.message);
        // });
      },
      numToChinese: function (num) {
        if (isNaN(num)) {
          return 'N';
        } else {
          var pos = ['', '', '十', '百', '千', '万', '十万', '百万', '千万', '亿'];
          var covert = ['零', '一', '二', '三', '四', '五', '六', '七', '八', '九'];
          var str = new String(num);
          if (str.length > 9) {
            return 'N';
          } else {
            var res = num < 0 ? '负' : '';
            var isZero = false;
            var item;
            for (var i = 0; i < str.length; i++) {
              item = parseInt(str.substr(i, 1));

              if (item == 0) {
                isZero = true;
              } else {
                if (isZero == true) {
                  res += '零';
                  isZero = false;
                }

                if (pos[str.length - i].length <= 1 || (i + 1 < str.length && parseInt(str.substr(i + 1, 1)) == 0)) {
                  res += covert[item] + pos[str.length - i];
                } else {
                  res += covert[item] + pos[str.length - i].substr(0, 1);
                }
              }
            }

            return res;
          }
        }
      },
      addAppointment: function (data, callback) {
        var url = "https://" + Variable.url + "/client/memMng/memAppointment/addAppointmentByIonic?" + $.param(data) + "&callback=JSON_CALLBACK";
        $http.jsonp(url).success(
          function (ret) {
            callback(ret);
          }
        ).error(function (err) {
          console.log('err:' + err);
        });
      },
      checkUpdate: function () {
        cordova.getAppVersion.getVersionNumber().then(function (version) {
          if (device.platform == "Android") {
            var url = "https://" + Variable.url + "/index/returnAppVersion?callback=JSON_CALLBACK";
            $http.jsonp(url).success(
              function (ret) {
                if (ret.android && ret.android > version) {
                  var updatePopup = $ionicPopup.show({
                    title: '',
                    template: '<img src="img/icon.png" width="60" height="60" style="margin-top: 10px; margin-bottom: 10px;"></img><p style="font-size: 15px;">发现新版本：' + ret.android + '</p>',
                    cssClass: 'update-popup',
                    buttons: [{
                      text: '暂不更新'
                    }, {
                      text: '<b>更新</b>',
                      type: 'button-balanced',
                      onTap: function (e) {
                        e.preventDefault();
                        $cordovaInAppBrowser.open('https://a.app.qq.com/o/simple.jsp?pkgname=zufun.cn', '_system');
                      }
                    },]
                  });
                }
              }
            ).error(function (err) {
              console.log('err:' + err);
            });
          } else if (device.platform == "iOS") {
            var url = "https://itunes.apple.com/cn/lookup?id=1189008045";
            $http.post(url).success(
              function (ret) {
                if (ret.results && ret.results[0] && ret.results[0]['version'] && ret.results[0]['version'] > version) {
                  var updatePopup = $ionicPopup.show({
                    title: '',
                    template: '<img src="img/icon.png" width="60" height="60" style="margin-top: 10px; margin-bottom: 10px;"></img><p style="font-size: 15px;">发现新版本：' + ret.results[0]['version'] + '</p>',
                    cssClass: 'update-popup',
                    buttons: [{
                      text: '暂不更新'
                    }, {
                      text: '<b>更新</b>',
                      type: 'button-balanced',
                      onTap: function (e) {
                        e.preventDefault();
                        $cordovaInAppBrowser.open('itms-appss://apps.apple.com/cn/app/id1189008045', '_system');
                      }
                    },]
                  });
                }
              }
            ).error(function (err) {
              console.log('err:' + err);
            });
          }
        });
      }
    };
  })


  //列表筛选数据；
  .factory('Search', function () {
    return {
      citys: [
        { 'name': "保定", 'id': 3609, 'ct_index': 'bd' },
        { 'name': "包头", 'id': 3610, 'ct_index': 'bt' },
        { 'name': "北京", 'id': 3611, 'ct_index': 'bj' },
        { 'name': "沧州", 'id': 3612, 'ct_index': 'cangzhou' },
        { 'name': "长春", 'id': 3613, 'ct_index': 'cc' },
        { 'name': "长沙", 'id': 3614, 'ct_index': 'cs' },
        { 'name': "常州", 'id': 3615, 'ct_index': 'cz' },
        { 'name': "成都", 'id': 3616, 'ct_index': 'cd' },
        { 'name': "重庆", 'id': 3617, 'ct_index': 'cq' },
        { 'name': "大连", 'id': 3618, 'ct_index': 'dl' },
        { 'name': "东莞", 'id': 3620, 'ct_index': 'dg' },
        { 'name': "佛山", 'id': 3621, 'ct_index': 'fs' },
        { 'name': "福州", 'id': 3622, 'ct_index': 'fz' },
        { 'name': "广州", 'id': 3623, 'ct_index': 'gz' },
        { 'name': "桂林", 'id': 4533, 'ct_index': 'gl' },
        { 'name': "贵阳", 'id': 3624, 'ct_index': 'gl' },
        { 'name': "哈尔滨", 'id': 3625, 'ct_index': 'hrb' },
        { 'name': "海口", 'id': 3626, 'ct_index': 'haikou' },
        { 'name': "邯郸", 'id': 3627, 'ct_index': 'hd' },
        { 'name': "杭州", 'id': 3628, 'ct_index': 'hz' },
        { 'name': "合肥", 'id': 3629, 'ct_index': 'hf' },
        { 'name': "淮安", 'id': 3630, 'ct_index': 'ha' },
        { 'name': "呼和浩特", 'id': 3631, 'ct_index': 'hu' },
        { 'name': "惠州", 'id': 3632, 'ct_index': 'huizhou' },
        { 'name': "湖州", 'id': 3686, 'ct_index': 'huzhou' },
        { 'name': "江门", 'id': 3633, 'ct_index': 'jm' },
        { 'name': "嘉兴", 'id': 3634, 'ct_index': 'jx' },
        { 'name': "吉林", 'id': 3635, 'ct_index': 'jl' },
        { 'name': "济南", 'id': 3636, 'ct_index': 'jn' },
        { 'name': "金华", 'id': 3637, 'ct_index': 'jh' },
        { 'name': "济宁", 'id': 3638, 'ct_index': 'jining' },
        { 'name': "昆明", 'id': 3639, 'ct_index': 'km' },
        { 'name': "廊坊", 'id': 4502, 'ct_index': 'lf' },
        { 'name': "兰州", 'id': 3640, 'ct_index': 'lz' },
        { 'name': "临沂", 'id': 3641, 'ct_index': 'linyi' },
        { 'name': "柳州", 'id': 3642, 'ct_index': 'liuzhou' },
        { 'name': "洛阳", 'id': 3643, 'ct_index': 'ly' },
        { 'name': "南昌", 'id': 3645, 'ct_index': 'nc' },
        { 'name': "南京", 'id': 3646, 'ct_index': 'nj' },
        { 'name': "南宁", 'id': 3647, 'ct_index': 'nn' },
        { 'name': "南通", 'id': 3648, 'ct_index': 'nt' },
        { 'name': "宁波", 'id': 3649, 'ct_index': 'nb' },
        { 'name': "青岛", 'id': 3650, 'ct_index': 'qd' },
        { 'name': "泉州", 'id': 3651, 'ct_index': 'qz' },
        { 'name': "三亚", 'id': 4532, 'ct_index': 'sanya' },
        { 'name': "上海", 'id': 3652, 'ct_index': 'sh' },
        { 'name': "汕头", 'id': 3653, 'ct_index': 'st' },
        { 'name': "绍兴", 'id': 3654, 'ct_index': 'sx' },
        { 'name': "沈阳", 'id': 3655, 'ct_index': 'sy' },
        { 'name': "深圳", 'id': 3399, 'ct_index': 'sz' },
        { 'name': "石家庄", 'id': 3656, 'ct_index': 'sjz' },
        { 'name': "苏州", 'id': 3657, 'ct_index': 'su' },
        { 'name': "泰安", 'id': 3658, 'ct_index': 'ta' },
        { 'name': "太原", 'id': 3659, 'ct_index': 'ty' },
        { 'name': "泰州", 'id': 3661, 'ct_index': 'taizhou' },
        { 'name': "唐山", 'id': 3662, 'ct_index': 'ts' },
        { 'name': "天津", 'id': 3663, 'ct_index': 'tj' },
        { 'name': "台州", 'id': 3660, 'ct_index': 'tz' },
        { 'name': "威海", 'id': 3665, 'ct_index': 'weihai' },
        { 'name': "温州", 'id': 3666, 'ct_index': 'wz' },
        { 'name': "武汉", 'id': 3667, 'ct_index': 'wh' },
        { 'name': "芜湖", 'id': 3685, 'ct_index': 'wuhu' },
        { 'name': "乌鲁木齐", 'id': 3668, 'ct_index': 'wu' },
        { 'name': "无锡", 'id': 3669, 'ct_index': 'wx' },
        { 'name': "厦门", 'id': 3670, 'ct_index': 'xm' },
        { 'name': "西安", 'id': 3671, 'ct_index': 'xa' },
        { 'name': "襄阳", 'id': 3672, 'ct_index': 'xy' },
        { 'name': "西宁", 'id': 3673, 'ct_index': 'xn' },
        { 'name': "许昌", 'id': 4503, 'ct_index': 'xc' },
        { 'name': "徐州", 'id': 3674, 'ct_index': 'xz' },
        { 'name': "盐城", 'id': 3675, 'ct_index': 'yancheng' },
        { 'name': "扬州", 'id': 3676, 'ct_index': 'yz' },
        { 'name': "烟台", 'id': 3677, 'ct_index': 'yt' },
        { 'name': "宜昌", 'id': 3678, 'ct_index': 'yichang' },
        { 'name': "银川", 'id': 3679, 'ct_index': 'yc' },
        { 'name': "漳州", 'id': 4504, 'ct_index': 'zhangzhou' },
        { 'name': "郑州", 'id': 3680, 'ct_index': 'zz' },
        { 'name': "镇江", 'id': 3681, 'ct_index': 'zj' },
        { 'name': "中山", 'id': 3682, 'ct_index': 'zs' },
        { 'name': "珠海", 'id': 3683, 'ct_index': 'zh' },
        { 'name': "淄博", 'id': 3684, 'ct_index': 'zb' }
      ],
      att_deposit: [
        {
          id: 1,
          name: '押一付一'
        },
        {
          id: 2,
          name: '押二付一'
        },
        {
          id: 4,
          name: '押一付三'
        },
        {
          id: 3,
          name: '押三付一'
        }
      ],
      att_min_period: [
        {
          id: 5,
          name: '不限'
        },
        {
          id: 1,
          name: '一个月'
        },
        {
          id: 2,
          name: '三个月'
        },
        {
          id: 3,
          name: '半年'
        },
        {
          id: 4,
          name: '一年'
        }
      ]
    };
  })
  //post
  .factory('Jsonp', function ($http) {
    return {
      // 上拉加载
      pullLoading: function (url, data, $scope, callback) {
        var myUrl = url + "?cityid=" + data.city_id + "&url=" + data.url + "&callback=JSON_CALLBACK";
        var vm = $scope.vm = {
          moredata: false,
          messages: [],
          pagination: {
            perPage: 5,
            currentPage: 1
          },
          init: function () {
            $http.jsonp(myUrl).success(
              function (ret) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.vm.moredata = true;
                callback(ret);
              }
            ).error(function (err) {
              console.log('err:' + err);
            });
          },
          show: function (message) {
            if (message.static) {
              message.static = false;
            } else {
              message.static = true;
            }
          },
          // doRefresh: function () {
          //   $timeout(function () {
          //     $scope.$broadcast('scroll.refreshComplete');
          //   }, 1000);
          // },
          loadMore: function () {
            vm.pagination.currentPage += 1;
            var page = vm.pagination.currentPage;

            myUrl = url + "?cityid=" + data.city_id + "&url=" + data.url + "&getMore=yes&page=" + page + "&callback=JSON_CALLBACK";
            $http.jsonp(myUrl).success(
              function (ret) {
                callback(ret);
                $scope.$broadcast('scroll.infiniteScrollComplete');
              }
            ).error(function (err) {
              console.log('err:' + err);
            });
          }
        };
        vm.init();
      }
    };
  })
  //md5加密
  .factory('Md5', function () {
    return {
      set: function (string) {
        function md5_RotateLeft (lValue, iShiftBits) {
          return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
        }

        function md5_AddUnsigned (lX, lY) {
          var lX4, lY4, lX8, lY8, lResult;
          lX8 = (lX & 0x80000000);
          lY8 = (lY & 0x80000000);
          lX4 = (lX & 0x40000000);
          lY4 = (lY & 0x40000000);
          lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
          if (lX4 & lY4) {
            return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
          }
          if (lX4 | lY4) {
            if (lResult & 0x40000000) {
              return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
            } else {
              return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
            }
          } else {
            return (lResult ^ lX8 ^ lY8);
          }
        }

        function md5_F (x, y, z) {
          return (x & y) | ((~x) & z);
        }

        function md5_G (x, y, z) {
          return (x & z) | (y & (~z));
        }

        function md5_H (x, y, z) {
          return (x ^ y ^ z);
        }

        function md5_I (x, y, z) {
          return (y ^ (x | (~z)));
        }

        function md5_FF (a, b, c, d, x, s, ac) {
          a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_F(b, c, d), x), ac));
          return md5_AddUnsigned(md5_RotateLeft(a, s), b);
        };

        function md5_GG (a, b, c, d, x, s, ac) {
          a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_G(b, c, d), x), ac));
          return md5_AddUnsigned(md5_RotateLeft(a, s), b);
        };

        function md5_HH (a, b, c, d, x, s, ac) {
          a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_H(b, c, d), x), ac));
          return md5_AddUnsigned(md5_RotateLeft(a, s), b);
        };

        function md5_II (a, b, c, d, x, s, ac) {
          a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_I(b, c, d), x), ac));
          return md5_AddUnsigned(md5_RotateLeft(a, s), b);
        };

        function md5_ConvertToWordArray (string) {
          var lWordCount;
          var lMessageLength = string.length;
          var lNumberOfWords_temp1 = lMessageLength + 8;
          var lNumberOfWords_temp2 = (lNumberOfWords_temp1 - (lNumberOfWords_temp1 % 64)) / 64;
          var lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
          var lWordArray = Array(lNumberOfWords - 1);
          var lBytePosition = 0;
          var lByteCount = 0;
          while (lByteCount < lMessageLength) {
            lWordCount = (lByteCount - (lByteCount % 4)) / 4;
            lBytePosition = (lByteCount % 4) * 8;
            lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount) << lBytePosition));
            lByteCount++;
          }
          lWordCount = (lByteCount - (lByteCount % 4)) / 4;
          lBytePosition = (lByteCount % 4) * 8;
          lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
          lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
          lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
          return lWordArray;
        };

        function md5_WordToHex (lValue) {
          var WordToHexValue = "",
            WordToHexValue_temp = "",
            lByte, lCount;
          for (lCount = 0; lCount <= 3; lCount++) {
            lByte = (lValue >>> (lCount * 8)) & 255;
            WordToHexValue_temp = "0" + lByte.toString(16);
            WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length - 2, 2);
          }
          return WordToHexValue;
        };

        function md5_Utf8Encode (string) {
          string = string.replace(/\r\n/g, "\n");
          var utftext = "";
          for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
              utftext += String.fromCharCode(c);
            } else if ((c > 127) && (c < 2048)) {
              utftext += String.fromCharCode((c >> 6) | 192);
              utftext += String.fromCharCode((c & 63) | 128);
            } else {
              utftext += String.fromCharCode((c >> 12) | 224);
              utftext += String.fromCharCode(((c >> 6) & 63) | 128);
              utftext += String.fromCharCode((c & 63) | 128);
            }
          }
          return utftext;
        };
        var x = Array();
        var k, AA, BB, CC, DD, a, b, c, d;
        var S11 = 7,
          S12 = 12,
          S13 = 17,
          S14 = 22;
        var S21 = 5,
          S22 = 9,
          S23 = 14,
          S24 = 20;
        var S31 = 4,
          S32 = 11,
          S33 = 16,
          S34 = 23;
        var S41 = 6,
          S42 = 10,
          S43 = 15,
          S44 = 21;
        string = md5_Utf8Encode(string);
        x = md5_ConvertToWordArray(string);
        a = 0x67452301;
        b = 0xEFCDAB89;
        c = 0x98BADCFE;
        d = 0x10325476;
        for (k = 0; k < x.length; k += 16) {
          AA = a;
          BB = b;
          CC = c;
          DD = d;
          a = md5_FF(a, b, c, d, x[k + 0], S11, 0xD76AA478);
          d = md5_FF(d, a, b, c, x[k + 1], S12, 0xE8C7B756);
          c = md5_FF(c, d, a, b, x[k + 2], S13, 0x242070DB);
          b = md5_FF(b, c, d, a, x[k + 3], S14, 0xC1BDCEEE);
          a = md5_FF(a, b, c, d, x[k + 4], S11, 0xF57C0FAF);
          d = md5_FF(d, a, b, c, x[k + 5], S12, 0x4787C62A);
          c = md5_FF(c, d, a, b, x[k + 6], S13, 0xA8304613);
          b = md5_FF(b, c, d, a, x[k + 7], S14, 0xFD469501);
          a = md5_FF(a, b, c, d, x[k + 8], S11, 0x698098D8);
          d = md5_FF(d, a, b, c, x[k + 9], S12, 0x8B44F7AF);
          c = md5_FF(c, d, a, b, x[k + 10], S13, 0xFFFF5BB1);
          b = md5_FF(b, c, d, a, x[k + 11], S14, 0x895CD7BE);
          a = md5_FF(a, b, c, d, x[k + 12], S11, 0x6B901122);
          d = md5_FF(d, a, b, c, x[k + 13], S12, 0xFD987193);
          c = md5_FF(c, d, a, b, x[k + 14], S13, 0xA679438E);
          b = md5_FF(b, c, d, a, x[k + 15], S14, 0x49B40821);
          a = md5_GG(a, b, c, d, x[k + 1], S21, 0xF61E2562);
          d = md5_GG(d, a, b, c, x[k + 6], S22, 0xC040B340);
          c = md5_GG(c, d, a, b, x[k + 11], S23, 0x265E5A51);
          b = md5_GG(b, c, d, a, x[k + 0], S24, 0xE9B6C7AA);
          a = md5_GG(a, b, c, d, x[k + 5], S21, 0xD62F105D);
          d = md5_GG(d, a, b, c, x[k + 10], S22, 0x2441453);
          c = md5_GG(c, d, a, b, x[k + 15], S23, 0xD8A1E681);
          b = md5_GG(b, c, d, a, x[k + 4], S24, 0xE7D3FBC8);
          a = md5_GG(a, b, c, d, x[k + 9], S21, 0x21E1CDE6);
          d = md5_GG(d, a, b, c, x[k + 14], S22, 0xC33707D6);
          c = md5_GG(c, d, a, b, x[k + 3], S23, 0xF4D50D87);
          b = md5_GG(b, c, d, a, x[k + 8], S24, 0x455A14ED);
          a = md5_GG(a, b, c, d, x[k + 13], S21, 0xA9E3E905);
          d = md5_GG(d, a, b, c, x[k + 2], S22, 0xFCEFA3F8);
          c = md5_GG(c, d, a, b, x[k + 7], S23, 0x676F02D9);
          b = md5_GG(b, c, d, a, x[k + 12], S24, 0x8D2A4C8A);
          a = md5_HH(a, b, c, d, x[k + 5], S31, 0xFFFA3942);
          d = md5_HH(d, a, b, c, x[k + 8], S32, 0x8771F681);
          c = md5_HH(c, d, a, b, x[k + 11], S33, 0x6D9D6122);
          b = md5_HH(b, c, d, a, x[k + 14], S34, 0xFDE5380C);
          a = md5_HH(a, b, c, d, x[k + 1], S31, 0xA4BEEA44);
          d = md5_HH(d, a, b, c, x[k + 4], S32, 0x4BDECFA9);
          c = md5_HH(c, d, a, b, x[k + 7], S33, 0xF6BB4B60);
          b = md5_HH(b, c, d, a, x[k + 10], S34, 0xBEBFBC70);
          a = md5_HH(a, b, c, d, x[k + 13], S31, 0x289B7EC6);
          d = md5_HH(d, a, b, c, x[k + 0], S32, 0xEAA127FA);
          c = md5_HH(c, d, a, b, x[k + 3], S33, 0xD4EF3085);
          b = md5_HH(b, c, d, a, x[k + 6], S34, 0x4881D05);
          a = md5_HH(a, b, c, d, x[k + 9], S31, 0xD9D4D039);
          d = md5_HH(d, a, b, c, x[k + 12], S32, 0xE6DB99E5);
          c = md5_HH(c, d, a, b, x[k + 15], S33, 0x1FA27CF8);
          b = md5_HH(b, c, d, a, x[k + 2], S34, 0xC4AC5665);
          a = md5_II(a, b, c, d, x[k + 0], S41, 0xF4292244);
          d = md5_II(d, a, b, c, x[k + 7], S42, 0x432AFF97);
          c = md5_II(c, d, a, b, x[k + 14], S43, 0xAB9423A7);
          b = md5_II(b, c, d, a, x[k + 5], S44, 0xFC93A039);
          a = md5_II(a, b, c, d, x[k + 12], S41, 0x655B59C3);
          d = md5_II(d, a, b, c, x[k + 3], S42, 0x8F0CCC92);
          c = md5_II(c, d, a, b, x[k + 10], S43, 0xFFEFF47D);
          b = md5_II(b, c, d, a, x[k + 1], S44, 0x85845DD1);
          a = md5_II(a, b, c, d, x[k + 8], S41, 0x6FA87E4F);
          d = md5_II(d, a, b, c, x[k + 15], S42, 0xFE2CE6E0);
          c = md5_II(c, d, a, b, x[k + 6], S43, 0xA3014314);
          b = md5_II(b, c, d, a, x[k + 13], S44, 0x4E0811A1);
          a = md5_II(a, b, c, d, x[k + 4], S41, 0xF7537E82);
          d = md5_II(d, a, b, c, x[k + 11], S42, 0xBD3AF235);
          c = md5_II(c, d, a, b, x[k + 2], S43, 0x2AD7D2BB);
          b = md5_II(b, c, d, a, x[k + 9], S44, 0xEB86D391);
          a = md5_AddUnsigned(a, AA);
          b = md5_AddUnsigned(b, BB);
          c = md5_AddUnsigned(c, CC);
          d = md5_AddUnsigned(d, DD);
        }
        return (md5_WordToHex(a) + md5_WordToHex(b) + md5_WordToHex(c) + md5_WordToHex(d)).toLowerCase();
      }
    };
  });